var contentID;
var contentVersion;

var pageWidth;
var pageHeight;

var mode;
var drawConfig;

//線や画像の格納
var objArray;

//ダブルクリックの判定
var doubleFlag;
//ダブルクリックの判別のためのタイマー
var st;

//raphaelの描画領域
var paper;

var pX;
var pY;

var mFlag;
var dFlag;

var ictMode;

var menuMode;
var menuSize;
var menuTween;

//各種ツールの変数
var pColor;
var pSize;
var pAlpha;
var mColor;
var mSize;
var mAlpha;
var tColor;
var tSize;

var figureSelect;
var stampSelect;

var penMode;
var openFlag;

var textIndex;

var cScale;

var colorArray = ['#000000', '#FFFFFF', '#D45D87', '#F3C759', '#FFEE55', '#5EC84E', '#44A5CB', '#6A8CC7'];
var pSizeArray = [4, 12, 24, 32];
var mSizeArray = [4, 12, 24, 32];
var tSizeArray = [20, 24, 28, 32];
var alphaArray = [0.25, 0.5, 0.75, 1];

var defFont;

var downEvent;
var moveEvent;
var upEvent;

//バージョンのチェック
var checkURL;


window.onload=function()
{
	try
	{
		ictMode = false;
		
		var dc = navigator.userAgent;
		
		//スマートフォン
		if(dc.indexOf('iPhone') > 0 || dc.indexOf('iPod') > 0 || dc.indexOf('Android') > 0 && dc.indexOf('Mobile') > 0)
		{
			drawConfig = false;
		}
		//タブレット
		else if(dc.indexOf('iPad') > 0 || dc.indexOf('Android') > 0)
		{
			drawConfig = false;
		}
		//IE10以下の場合
		else if(dc.indexOf('MSIE') > 0)
		{
			drawConfig = true;
		}
		else
		{
			drawConfig = false;
		}
		
		//スマートフォン
		if(dc.indexOf('iPhone') >= 0 || dc.indexOf('iPod') >= 0 || dc.indexOf('Phone') >= 0 || (dc.indexOf('Android') >= 0 && dc.indexOf('Mobile') >= 0) || dc.indexOf('BlackBerry') >= 0)
		{
			mFlag = true;
		}
		//タブレット
		else if(dc.indexOf('iPad') >= 0 || dc.indexOf('Android') >= 0)
		{
			mFlag = true;
		}
		else
		{
			mFlag = false;
		}
		
		
		//スマホ・タブレットと予測
		if(mFlag)
		{
			downEvent = "touchstart";
			moveEvent = "touchmove";
			upEvent = "touchend";
		}
		//PCと予測
		else
		{
			/*
			//タッチパネル対応かを判定
			if(window.ontouchstart == null)
			{
				downEvent = "touchstart";
				moveEvent = "touchmove";
				upEvent = "touchend";
			}
			else
			{
				downEvent = "mousedown";
				moveEvent = "mousemove";
				upEvent = "mouseup";
			}
			*/
			
			downEvent = "mousedown";
			moveEvent = "mousemove";
			upEvent = "mouseup";
		}
		
		
		mode ='select';
		if(drawConfig == true)
		{
			document.getElementById('svgCanvas').style.display='none';
		}
		else
		{
			document.getElementById('svgCanvas').style.pointerEvents = 'none';
		}
		
		//ファイル名からIDを設定
		contentID = window.location.href;
		contentID = contentID.substring(contentID.lastIndexOf("/")+1, contentID.lastIndexOf("."));
		
		defFont = uu.font.detect(uu.body());
		
		doubleFlag = false;
		
		//初期化
		objArray = [];
		
		pageWidth = 920;
		
		try
		{
			//個別ページでの設定がある場合
			pageHeight = getContentHeight();
		}
		catch(t)
		{
			//個別の設定がない場合
			pageHeight = 560;
		}
		
		paper = Raphael('svgCanvas', pageWidth, pageHeight);
		
		document.getElementById('main').style.width = pageWidth + 'px';
		document.getElementById('main').style.height = pageHeight + 'px';
		document.getElementById('contentBlock').style.width = pageWidth + 'px';
		document.getElementById('contentBlock').style.height = pageHeight + 'px';
		
		document.getElementById('dataBalloon').style.display = 'none';
		
		document.getElementById('penBalloon').style.display = 'none';
		document.getElementById('stampBalloon').style.display = 'none';
		document.getElementById('figureBalloon').style.display = 'none';
		document.getElementById('textBalloon').style.display = 'none';
		
		document.getElementById('hr0').style.top = "49px";
		document.getElementById('hr1').style.top = "99px";
		document.getElementById('hr2').style.top = "149px";
		document.getElementById('hr3').style.top = "199px";
		document.getElementById('hr4').style.top = "249px";
		
		changeToolBoxDisplay(false);
		
		//iOSでのセーブ・ロードは無効
		if(dc.indexOf('iPad') > 0 || dc.indexOf('iPod') > 0 || dc.indexOf('iPhone') > 0)
		{
			document.getElementById('dataConfigBtn').style.display = "none";
		}
		else
		{
			document.getElementById('dataConfigBtn').style.display = "inline";
		}
		
		//ICTではセーブロードなし
		if(ictMode)
		{
			document.getElementById('dataConfigBtn').style.display = "none";
		}
		
		document.getElementById('saveBtn').style.marginTop = "5px";
		document.getElementById('saveBtn').style.marginLeft = "5px";
		document.getElementById('loadBtn').style.marginTop = "5px";
		document.getElementById('loadBtn').style.marginLeft = "5px";
		
		//ツールのボタン設定
		document.getElementById('toolDisplayBtn').addEventListener('click', modeChange);
		document.getElementById('drawBtn').addEventListener('click', modeChange);
		document.getElementById('penModeBtn').addEventListener('click', modeChange);
		document.getElementById('markerModeBtn').addEventListener('click', modeChange);
		
		document.getElementById('stampBtn').addEventListener('click', modeChange);
		document.getElementById('figureBtn').addEventListener('click', modeChange);
		document.getElementById('textBtn').addEventListener('click', modeChange);
		document.getElementById('eraserBtn').addEventListener('click', modeChange);
		
		document.getElementById("dataConfigBtn").addEventListener('click', openDataHandler);
		
		
		var figureList = document.getElementsByClassName("figureImage");
		
		for(var i=0; i<figureList.length; i++)
		{
			figureList[i].addEventListener('click', changeFigureSelect);
			
			if(i==0)
			{
				figureSelect = $(figureList[i]).attr("id");
				$(figureList[i]).css("border", "1px solid #FF0000");
			}
			else
			{
				$(figureList[i]).css("border", "1px solid #FFFFFF");
			}
		}
		
		//スタンプ
		var stampList = document.getElementsByClassName('stampImage');
		
		for(var i=0; i<stampList.length; i++)
		{
			stampList[i].addEventListener('click', changeStampSelect);
			
			if(i==0)
			{
				stampSelect = $(stampList[i]).attr("id");
				$(stampList[i]).css("border", "1px solid #FF0000");
			}
			else
			{
				$(stampList[i]).css("border", "1px solid #FFFFFF");
			}
		}
		
		if(ictMode)
		{
			$('#svgCanvas').on('mousedown touchstart', drawStart);
		}
		else if(mFlag)
		{
			document.getElementById('svgCanvas').addEventListener('touchstart', drawStart);
		}
		else
		{
			document.getElementById('svgCanvas').addEventListener('mousedown', drawStart);
		}
		
		window.addEventListener('scroll', toolPositionChange);
		
		window.addEventListener('resize', windowResize);
		
		$("#controlBlock").scroll(controlBlockScroll);
		
		//ペンなどの設定
		pColor = 0;
		pSize = 0;
		pAlpha = 3;
		
		mColor = 0;
		mSize = 0;
		mAlpha = 3;
		
		penMode = true;
		
		tColor = 0;
		tSize = 0;
		
		fgrMode = 0;
		stmMode = 0;
		
		textIndex = -1;
		
		if(ictMode)
		{
			$("#svgCanvas").on('mousedown touchstart', setTextHandler);
		}
		else if(mFlag)
		{
			document.getElementById("svgCanvas").addEventListener('touchstart', setTextHandler);
		}
		else
		{
			document.getElementById("svgCanvas").addEventListener('mousedown', setTextHandler);
		}
		
		document.getElementById('penModeBtn').style.border = '1px #FF0000 solid';
		
		document.getElementById('pColor0').style.border = '1px #FF0000 solid';
		
		document.getElementById('pSize0').style.border = '1px #FF0000 solid';
		document.getElementById('mSize0').style.border = '1px #FF0000 solid';
		
		document.getElementById('pAlpha3').style.border = '1px #FF0000 solid';
		document.getElementById('mAlpha3').style.border = '1px #FF0000 solid';
		
		document.getElementById('tColor0').style.border = '1px #FF0000 solid';
		document.getElementById('tSize0').style.border = '1px #FF0000 solid';
		
		document.getElementById('markerSizeBlock').style.display = 'none';
		document.getElementById('markerAlphaBlock').style.display = 'none';
		
		//ツールのイベント追加
		for(var i=0; i<8; i++)
		{
			if(i < 4)
			{
				document.getElementById('pSize'+i).addEventListener('click', changeConfigHandler);
				document.getElementById('mSize'+i).addEventListener('click', changeConfigHandler);
				
				document.getElementById('pAlpha'+i).addEventListener('click', changeConfigHandler);
				document.getElementById('mAlpha'+i).addEventListener('click', changeConfigHandler);
				
				document.getElementById('tSize'+i).addEventListener('click', changeConfigHandler);
			}
			
			document.getElementById('pColor'+i).addEventListener('click', changeConfigHandler);
			document.getElementById('tColor'+i).addEventListener('click', changeConfigHandler);
		}
		
		
		
		cScale = 1;
		
		document.getElementById("zoomIn").addEventListener('click', changeZoomButtonHandler);
		document.getElementById("zoomOut").addEventListener('click', changeZoomButtonHandler);		
		
		//セーブ
		$("#saveFile").on('click', saveHandler);
		
		//ロード
		$('#file_input').on('change', changeFile);
		
		//コンテンツ側で共通に宣言された初期設定の関数
		loadContentHandler();
		
		if(document.getElementById('graphCanvas') != undefined)
		{
			if(typeof zoomFlag == "undefined" || zoomFlag == true)
			{
				document.getElementById("configBlock").style.display = "block";
				
				//コンテンツの設定が完了してからサイズを設定
				if(typeof defScale != "undefined")
				{
					changeScaleHandler(defScale);
				}
				else
				{
					
					changeScaleHandler(1.25);
				}
				
				changeFormulaPositionHandler(2);
				
				cs.update();
			}
			else
			{
				
				document.getElementById("configBlock").style.display = "none";
			}
		}
		else
		{
			document.getElementById("zoomIn").style.display = "none";
			document.getElementById("zoomOut").style.display = "none";
		}
		
		document.getElementById("menuOpen").addEventListener("click", openMenuHandler);
		document.getElementById("menuClose").addEventListener("click", closeMenuHandler);
		
		document.getElementById("modalBlock").addEventListener("click", closeModalOutsideHandler);
		
		//ヘルプの設定
		setHelp();
		
		//データ操作表示
		if(document.getElementById("dataConfigBtn").style.display == "inline")
		{
			document.getElementById("dataTriangle").style.top = "5px";
			document.getElementById("penTriangle").style.top = "165px";
			document.getElementById("figureTriangle").style.top = "135px";
			document.getElementById("stampTriangle").style.top = "195px";
			document.getElementById("textTriangle").style.top = "265px";
		}
		//データ操作非表示
		else
		{
			document.getElementById("penTriangle").style.top = "120px";
			document.getElementById("figureTriangle").style.top = "145px";
			document.getElementById("stampTriangle").style.top = "205px";
			document.getElementById("textTriangle").style.top = "275px";
		}
		
		document.getElementById("configBtn").addEventListener("click", openConfigHandler);
		
		document.getElementById("logoImage").addEventListener("click", reloadContentHandler);
		
		//ツールの位置変更
		changeToolPosition();
		
		setTimeout(displayContent, 1000);
		
		$(document).on("contextmenu", function()
		{
			return false;
		});
		
		$("img").on("contextmenu", function()
		{
			return false;
		});
		
		$("input").on("contextmenu", function()
		{
			return false;
		});
	}
	catch(e)
	{
		alert('onload:' + e.toString());
	}
}

function reloadContentHandler(e)
{
	location.reload();
}

function controlBlockScroll(e)
{
	try
	{
	
		if(	typeof document.getElementById("selectBalloon_menu") != undefined
		&& document.getElementById("selectBalloon_menu").style.display == "inline-block")
		{
			document.getElementById("selectBalloon_menu").style.display = "none";
		}
	}
	catch(e)
	{
		
	}
}

function displayContent()
{
	try
	{
		$("#main").css("display", "block");
		$("#loadingTable").css("display", "none");
		
		setAnimeBalloonPosition();
	}
	catch(e)
	{
		
	}
}

function setMenuMode(m, n)
{
	try
	{
		menuMode = m;
		menuSize = n;
		menuTween = null;
		
		switch(m)
		{
			//左メニュー
			case 0:
				$("#menuBlock").css("border-right", "1px solid #999999");
				$("#menuBlock").css("position", "absolute");
				$("#menuBlock").css("width", n);
				$("#menuBlock").css("height", pageHeight);
				$("#menuBlock").css("top", 0);
				$("#menuBlock").css("left", 0);
				
				$("#closeBlock").css("width", "100%");
				$("#closeBlock").css("height", 30);
				$("#closeBlock").css("border-bottom", "1px solid #999999");
				
				$("#controlBlock").css("width", n);
				$("#controlBlock").css("height", pageHeight-30);
				
				$("#controlBlock").css("overflow-x", "auto");
				$("#controlBlock").css("overflow-y", "auto");
				
				$("#menuOpen").css("left", 10);
				$("#menuOpen").css("top", 10);
				break;
				
			//下メニュー
			case 1:
				$("#menuBlock").css("border-top", "1px solid #999999");
				$("#menuBlock").css("position", "absolute");
				$("#menuBlock").css("width", pageWidth-50);
				$("#menuBlock").css("height", n);
				$("#menuBlock").css("top", pageHeight-n);
				$("#menuBlock").css("left", 0);
				
				$("#closeBlock").css("width", 30);
				$("#closeBlock").css("height", n);
				$("#closeBlock").css("border-right", "1px solid #999999");
				
				$("#configBlock").css("bottom", n+20);
				
				$("#controlBlock").css("height", n);
				
				$("#controlBlock").css("width", pageWidth-82);
				
				$("#controlBlock").css("overflow-x", "auto");
				$("#controlBlock").css("overflow-y", "auto");
				
				$("#menuOpen").css("left", 10);
				$("#menuOpen").css("bottom", 10);
				
				document.getElementById("menuClose").src = "./img/menuClose1.png";
				document.getElementById("menuOpen").src = "./img/menuOpen1.png";
				break;
			
			//右下メニュー
			case 2:
				$("#menuBlock").css("border-top", "1px solid #999999");
				$("#menuBlock").css("border-left", "1px solid #999999");
				$("#menuBlock").css("position", "absolute");
				$("#menuBlock").css("width", pageWidth-50-(420));
				$("#menuBlock").css("height", n);
				$("#menuBlock").css("top", pageHeight-n);
				$("#menuBlock").css("left", 420);
				
				$("#closeBlock").css("width", 30);
				$("#closeBlock").css("height", n);
				$("#closeBlock").css("border-right", "1px solid #999999");
				
				$("#configBlock").css("bottom", n+20);
				
				$("#controlBlock").css("height", n);
				
				$("#controlBlock").css("width", pageWidth-82-420);
				
				$("#controlBlock").css("overflow-x", "auto");
				$("#controlBlock").css("overflow-y", "auto");
				
				$("#menuOpen").css("left", 420);
				$("#menuOpen").css("bottom", 10);
				
				document.getElementById("menuClose").src = "./img/menuClose1.png";
				document.getElementById("menuOpen").src = "./img/menuOpen1.png";
				break;
		}
	}
	catch(e)
	{
		alert("setMenuMode:" + e.toString());
	}
}

function openMenuHandler(e)
{
	try
	{
		if(menuTween == null)
		{
			switch(menuMode)
			{
				//左メニュー
				case 0:
					menuTween = $("#menuBlock").animate({left:0}, 500, function(){menuAnimeFinish()});
					break;
				
				//下メニュー
				case 1:
					menuTween = $("#menuBlock").animate({top:pageHeight-menuSize}, 500, function(){menuAnimeFinish()});
					
					if($("#configBlock").css("display") == "block")
					{
						$("#configBlock").animate({bottom:menuSize+20}, 500);
					}
					
					break;
				
				//下メニュー
				case 2:
					menuTween = $("#menuBlock").animate({top:pageHeight-menuSize}, 500, function(){menuAnimeFinish()});
					
					if($("#configBlock").css("display") == "block")
					{
						$("#configBlock").animate({bottom:menuSize+20}, 500);
					}
					
					break;
			}
		}
	}
	catch(e)
	{
		alert("closeMenu:" + e.toString());
	}
}

function closeMenuHandler(e)
{
	try
	{
		if(menuTween == null)
		{
			switch(menuMode)
			{
				//左メニュー
				case 0:
					menuTween = $("#menuBlock").animate({left:-menuSize-2}, 500, function(){menuAnimeFinish()});
					break;
				
				//下メニュー
				case 1:
					menuTween = $("#menuBlock").animate({top:pageHeight}, 500, function(){menuAnimeFinish()});
					
					if($("#configBlock").css("display") == "block")
					{
						$("#configBlock").animate({bottom:20}, 500);
					}
					
					break;
				
				//右下メニュー
				case 2:
					menuTween = $("#menuBlock").animate({top:pageHeight}, 500, function(){menuAnimeFinish()});
					
					if($("#configBlock").css("display") == "block")
					{
						$("#configBlock").animate({bottom:20}, 500);
					}
					
					break;
			}
		}
	}
	catch(e)
	{
		alert("closeMenu:" + e.toString());
	}
}

function menuAnimeFinish()
{
	menuTween = null;
}

function openDataHandler(e)
{
	try
	{
		if(document.getElementById("dataBalloon").style.display == "none")
		{
			if(	(mode == "pen" && document.getElementById("penBalloon").style.display == "block")
			||	(mode == "figure" && document.getElementById("figureBalloon").style.display == "block")
			||	(mode == "stamp" && document.getElementById("stampBalloon").style.display == "block")
			||	(mode == "text" && document.getElementById("textBalloon").style.display == "block"))
			{
				document.getElementById(mode + "Balloon").style.display = "none";
				
				openFlag = true;
			}
			else
			{
				openFlag = false;
			}
			
			document.getElementById("dataBalloon").style.display = "block";
		}
		else
		{
			document.getElementById("dataBalloon").style.display = "none";
			
			if(openFlag)
			{
				if(mode == "pen")
				{
					document.getElementById("penBalloon").style.display = "block";
				}
				else if(mode == "figure")
				{
					document.getElementById("figureBalloon").style.display = "block";
				}
				else if(mode == "stamp")
				{
					document.getElementById("stampBalloon").style.display = "block";
				}
				else if(mode == "text")
				{
					document.getElementById("textBalloon").style.display = "block";
				}
			}
		}
	}
	catch(e)
	{
		//alert("openDataHandler:" + e.toString());
	}
}

window.orientationchange = function()
{
	modalDisplayChange();
}

function changeToolBoxDisplay(f)
{
	try
	{
		if(f)
		{
			document.getElementById("toolDisplayBtn").src = "./img/tool-on.png";
			
			document.getElementById("drawBtn").style.display = "inline-block";
			document.getElementById("figureBtn").style.display = "inline-block";
			document.getElementById("stampBtn").style.display = "inline-block";
			document.getElementById("textBtn").style.display = "inline-block";
			document.getElementById("eraserBtn").style.display = "inline-block";
			
			document.getElementById("hr0").style.display = "block";
			document.getElementById("hr1").style.display = "block";
			document.getElementById("hr2").style.display = "block";
			document.getElementById("hr3").style.display = "block";
			document.getElementById("hr4").style.display = "block";
			
			document.getElementById("toolBox").style.height = "300px";
		}
		else
		{
			document.getElementById("toolDisplayBtn").src = "./img/tool-off.png";
			
			document.getElementById("drawBtn").style.display = "none";
			document.getElementById("figureBtn").style.display = "none";
			document.getElementById("stampBtn").style.display = "none";
			document.getElementById("textBtn").style.display = "none";
			document.getElementById("eraserBtn").style.display = "none";
			
			document.getElementById("hr0").style.display = "none";
			document.getElementById("hr1").style.display = "none";
			document.getElementById("hr2").style.display = "none";
			document.getElementById("hr3").style.display = "none";
			document.getElementById("hr4").style.display = "none";
			
			document.getElementById("toolBox").style.height = "50px";
		}
		
		
		
	}
	catch(e)
	{
		//alert("changeToolBoxDisplay:" + e.toString());
	}
}


function getDateString()
{
	try
	{
		var d = new Date();
		var str = d.getFullYear();
		
		if((d.getMonth()+1).toString().length == 1)
		{
			str += "0";
		}
		
		str += (d.getMonth()+1).toString();
		str += d.getDate().toString();
		
		str += "_";
		
		if(d.getHours().toString().length == 1)
		{
			str += "0";
		}
		str += d.getHours().toString();
		
		if(d.getMinutes().toString().length == 1)
		{
			str += "0";
		}
		str += d.getMinutes().toString();
		
		return str;
	}
	catch(e)
	{
		//alert("getDateString:" + e.toString());
	}
}

function changeZoomButtonHandler(e)
{
	try
	{
		var nScale;
		
		//拡大
		if(e.target.id == "zoomIn")
		{
			if(cScale >= 3)
			{
				return;
			}
			else
			{
				nScale = cScale + 0.1;
				
				if(nScale > 3)
				{
					nScale = 3;
				}
				
				changeScaleHandler(nScale);
			}
		}
		//縮小
		else
		{
			if(cScale <= 0.5)
			{
				return;
			}
			else
			{
				nScale = cScale - 0.1;
				
				if(nScale <= 0.5)
				{
					nScale = 0.5;
				}
				
				changeScaleHandler(nScale);
			}
		}
		
		
		if(document.getElementById('graphCanvas') != undefined)
		{
			changeFormulaPositionHandler(2);
		}
		
		cs.update();
	}
	catch(e)
	{
		//alert("changeZoomHandler" + e.toString());
	}
}

function changeScaleHandler(nScale)
{
	try
	{
		$("#graphCanvas").width(cW * nScale);
		$("#graphCanvas").height(cH * nScale);
		
		//位置の修正
		var left = $("#graphCanvas").css("left");
		var top = $("#graphCanvas").css("top");
		
		pX = Number(left.substring(0, left.length-2));
		pY = Number(top.substring(0, top.length-2));
		
		pX = bW/2-(-pX + bW/2)/cScale * nScale;
		pY = bH/2-(-pY + bH/2)/cScale * nScale;
		
		if(pX > 0)
		{
			pX = 0;
		}
		else if(pX < -$("#graphCanvas").width + bW)
		{
			pX = -$("#graphCanvas").width + bW;
		}
		
		if(pY > 0)
		{
			pY = 0;
		}
		else if(pY < -$("#graphCanvas").height + bH)
		{
			pY = -$("#graphCanvas").height + bH;
		}
		
		document.getElementById("graphCanvas").style.left = pX + "px";
		document.getElementById("graphCanvas").style.top = pY + "px";
		
		cScale = nScale;
		
		
		if(document.getElementById('graphCanvas') != undefined)
		{
			changeAxisPositionHandler();
		}
		
		cs.update();
	}
	catch(e)
	{
		//alert("changeScaleHandler:" + e.toString());
	}
}


function changeConfigHandler(e)
{
	try
	{
		var t0 = e.currentTarget.id.substring(0, e.currentTarget.id.length-1);
		var t1 = e.currentTarget.id.substring(e.currentTarget.id.length-1, e.currentTarget.id.length);
		
		var str = t0 + eval(t0).toString();
		
		//ペン，マーカーの色
		if(t0 == "pColor")
		{
			document.getElementById("pColor"+pColor).style.border = '1px #000000 solid';
			
			document.getElementById("pColor"+t1).style.border = '1px #FF0000 solid';
			
			pColor = t1;
			mColor = t1;
		}
		//ペン，マーカーの大きさ
		else if(t0 == "pSize" || t0 == "mSize")
		{
			document.getElementById("pSize"+pSize).style.border = '1px #000000 solid';
			document.getElementById("mSize"+mSize).style.border = '1px #000000 solid';
			
			document.getElementById("pSize"+t1).style.border = '1px #FF0000 solid';
			document.getElementById("mSize"+t1).style.border = '1px #FF0000 solid';
			
			pSize = t1;
			mSize = t1;
		}
		//ペン，マーカーの透明度
		else if(t0 == "pAlpha" || t0 == "mAlpha")
		{
			document.getElementById("pAlpha"+pAlpha).style.border = '1px #000000 solid';
			document.getElementById("mAlpha"+mAlpha).style.border = '1px #000000 solid';
			
			document.getElementById("pAlpha"+t1).style.border = '1px #FF0000 solid';
			document.getElementById("mAlpha"+t1).style.border = '1px #FF0000 solid';
			
			pAlpha = t1;
			mAlpha = t1;
		}
		//テキストの場合
		else if(t0 == "tColor" || t0 == "tSize")
		{
			document.getElementById(str).style.border = '1px #000000 solid';
			e.currentTarget.style.border = '1px #FF0000 solid';
			
			eval(t0+"="+t1+";");
			
			if(textIndex != -1)
			{
				if(document.getElementById("addInput").style.display == "block")
				{
					if(t0 == "tColor")
					{
						document.getElementById("addInput").style.color = colorArray[tColor];
					}
					else
					{
						document.getElementById("addInput").style.fontSize = tSizeArray[tSize]+"px";
					}
				}
				else
				{
					if(t0 == "tColor")
					{
						paper.getById("txt"+textIndex).attr({"fill":colorArray[tColor], "stroke":colorArray[tColor]});
						objArray[textIndex][3] = tColor;
					}
					else
					{
						paper.getById("txt"+textIndex).attr({"font-size":tSizeArray[tSize]});
						objArray[textIndex][4] = tSize;
					}
				}
			}
		}
	}
	catch(e)
	{
		//alert("changeConfigHandler:" + e.toString());
	}
}

function toolConfigHandler(e)
{
	try
	{
		if($('#selectBtn').css('display') == 'none')
		{
			$('#penBtn').css('display', 'inline');
			$('#markerBtn').css('display', 'inline');
			$('#stampBtn').css('display', 'inline');
			$('#figureBtn').css('display', 'inline');
			$('#textBtn').css('display', 'inline');
			$('#eraserBtn').css('display', 'inline');
			
			//$('#imgBtn').css('display', 'inline');
			
			menuClose();
		}
		else
		{
			toolClose();
		}
	}
	catch(e)
	{
		//alert("toolConfigHandler:" + e.toString());
	}
}

function toolClose()
{
	try
	{
		var imgStr;
		
		switch(mode)
		{
			case 'select':
				imgStr = './img/select-on.png';
				break;
			case 'pen':
				imgStr = './img/pen-on.png';
				break;
			case 'marker':
				imgStr = './img/marker-on.png';
				break;
			case 'eraser':
				imgStr = './img/eraser-on.png';
				break;
			case 'stamp':
				imgStr = './img/stamp-on.png';
				break;
			case 'figure':
				imgStr = './img/figure-on.png';
				break;
			case 'text':
				imgStr = './img/text-on.png';
				break;
		}
		
		$('#useBtn').attr('src', imgStr);
		
		$('#penBtn').css('display', 'none');
		$('#markerBtn').css('display', 'none');
		$('#stampBtn').css('display', 'none');
		$('#eraserBtn').css('display', 'none');
		$('#imgBtn').css('display', 'none');
		
		$('#drawBalloon').css('display', 'none');
		$('#markerBalloon').css('display', 'none');
		$('#stampBalloon').css('display', 'none');
		$('#figureBalloon').css('display', 'none');
		$('#textBalloon').css('display', 'none');
	}
	catch(e)
	{
		//alert("toolClose:" + e.toString());
	}
}

function modeChange(e)
{
	try
	{
		//ツールを開く・閉じる
		if(e.target.id.toString() == "toolDisplayBtn")
		{
			//閉じる（コンテンツ操作に戻る）
			if(document.getElementById("toolDisplayBtn").src.indexOf("tool-on.png") != -1)
			{
				//ツール操作中の状態を解除
				releaseToolHandler(false);
				
				changeToolBoxDisplay(false);
				
				mode = "select";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "none";
				document.getElementById("figureBalloon").style.display = "none";
				document.getElementById("stampBalloon").style.display = "none";
				document.getElementById("textBalloon").style.display = "none";
			}
			//開く
			else
			{
				changeToolBoxDisplay(true);
				
				if(document.getElementById("drawBtn").src.indexOf("draw-on.png") != -1)
				{
					if(penMode)
					{
						mode = "pen";
					}
					else
					{
						mode = "marker";
					}
					
					document.getElementById("dataBalloon").style.display = "none";
					document.getElementById("penBalloon").style.display = "block";
					document.getElementById("figureBalloon").style.display = "none";
					document.getElementById("stampBalloon").style.display = "none";
					document.getElementById("textBalloon").style.display = "none";
				}
				else if(document.getElementById("figureBtn").src.indexOf("figure-on.png") != -1)
				{
					mode = "figure";
					
					figureNum = -1;
					
					document.getElementById("dataBalloon").style.display = "none";
					document.getElementById("penBalloon").style.display = "none";
					document.getElementById("figureBalloon").style.display = "block";
					document.getElementById("stampBalloon").style.display = "none";
					document.getElementById("textBalloon").style.display = "none";
				}
				else if(document.getElementById("stampBtn").src.indexOf("stamp-on.png") != -1)
				{
					mode = "stamp";
					
					document.getElementById("dataBalloon").style.display = "none";
					document.getElementById("penBalloon").style.display = "none";
					document.getElementById("figureBalloon").style.display = "none";
					document.getElementById("stampBalloon").style.display = "block";
					document.getElementById("textBalloon").style.display = "none";
				}
				else if(document.getElementById("textBtn").src.indexOf("text-on.png") != -1)
				{
					mode = "text";
					
					document.getElementById("dataBalloon").style.display = "none";
					document.getElementById("penBalloon").style.display = "none";
					document.getElementById("figureBalloon").style.display = "none";
					document.getElementById("stampBalloon").style.display = "none";
					document.getElementById("textBalloon").style.display = "block";
				}
				else
				{
					mode = "eraser";
					
					document.getElementById("dataBalloon").style.display = "none";
					document.getElementById("penBalloon").style.display = "none";
					document.getElementById("figureBalloon").style.display = "none";
					document.getElementById("stampBalloon").style.display = "none";
					document.getElementById("textBalloon").style.display = "none";
				}
			}
		}
		//ペンの選択
		else if(e.target.id.toString() == "drawBtn")
		{
			if(mode != "pen" && mode != "marker")
			{
				//ツール操作中の状態を解除
				releaseToolHandler(true);
				
				document.getElementById("drawBtn").src = "./img/draw-on.png";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "block";
				document.getElementById("figureBalloon").style.display = "none";
				document.getElementById("stampBalloon").style.display = "none";
				document.getElementById("textBalloon").style.display = "none";

				if(penMode)
				{
					mode = "pen";
				}
				else
				{
					mode = "marker";
				}
			}
			else
			{
				if(document.getElementById("penBalloon").style.display == "block")
				{
					document.getElementById("penBalloon").style.display = "none";
				}
				else
				{
					document.getElementById("penBalloon").style.display = "block";
				}
			}	
		}
		//自由線・直線の切替
		else if(e.target.id.toString().indexOf("ModeBtn") != -1)
		{
			if(e.target.id.toString() == "markerModeBtn" && penMode == true)
			{
				document.getElementById("penSizeBlock").style.display = "none";
				document.getElementById("markerSizeBlock").style.display = "block";
				document.getElementById("penAlphaBlock").style.display = "none";
				document.getElementById("markerAlphaBlock").style.display = "block";
				
				document.getElementById("penModeBtn").style.border = "1px #000000 solid";
				document.getElementById("markerModeBtn").style.border = "1px #FF0000 solid";
				
				mode = "marker";
				penMode = false;
			}
			else if(e.target.id.toString() == "penModeBtn" && penMode == false)
			{
				document.getElementById("penSizeBlock").style.display = "block";
				document.getElementById("markerSizeBlock").style.display = "none";
				document.getElementById("penAlphaBlock").style.display = "block";
				document.getElementById("markerAlphaBlock").style.display = "none";
				
				document.getElementById("penModeBtn").style.border = "1px #FF0000 solid";
				document.getElementById("markerModeBtn").style.border = "1px #000000 solid";
				
				mode = "pen";
				penMode = true;
			}
		}
		//図形
		else if(e.target.id.toString() == "figureBtn")
		{
			if(mode != "figure")
			{
				//ツール操作中の状態を解除
				releaseToolHandler(true);
				
				document.getElementById("figureBtn").src = "./img/figure-on.png";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "none";
				document.getElementById("figureBalloon").style.display = "block";
				document.getElementById("stampBalloon").style.display = "none";
				document.getElementById("textBalloon").style.display = "none";
				
				figureNum = -1;
				
				mode = "figure";
			}
			else
			{
				if(document.getElementById("figureBalloon").style.display == "block")
				{
					document.getElementById("figureBalloon").style.display = "none";
				}
				else
				{
					document.getElementById("figureBalloon").style.display = "block";
				}
			}
		}
		//スタンプ
		else if(e.target.id.toString() == "stampBtn")
		{
			if(mode != "stamp")
			{
				//ツール操作中の状態を解除
				releaseToolHandler(true);
				
				document.getElementById("stampBtn").src = "./img/stamp-on.png";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "none";
				document.getElementById("figureBalloon").style.display = "none";
				document.getElementById("stampBalloon").style.display = "block";
				document.getElementById("textBalloon").style.display = "none";
				
				mode = "stamp";
			}
			else
			{
				if(document.getElementById("stampBalloon").style.display == "block")
				{
					document.getElementById("stampBalloon").style.display = "none";
				}
				else
				{
					document.getElementById("stampBalloon").style.display = "block";
				}
			}
		}
		//テキスト
		else if(e.target.id.toString() == "textBtn")
		{
			if(mode != "text")
			{
				//ツール操作中の状態を解除
				releaseToolHandler(true);
				
				document.getElementById("textBtn").src = "./img/text-on.png";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "none";
				document.getElementById("figureBalloon").style.display = "none";
				document.getElementById("stampBalloon").style.display = "none";
				document.getElementById("textBalloon").style.display = "block";
				
				mode = "text";
			}
			else
			{
				//テキストの状態解除
				releaseToolHandler(false);
				
				if(document.getElementById("textBalloon").style.display == "block")
				{
					document.getElementById("textBalloon").style.display = "none";
				}
				else
				{
					document.getElementById("textBalloon").style.display = "block";
				}
			}
		}
		//削除
		else if(e.target.id.toString() == "eraserBtn")
		{
			if(mode != "eraser")
			{
				releaseToolHandler(true);
				
				document.getElementById("eraserBtn").src = "./img/eraser-on.png";
				
				document.getElementById("dataBalloon").style.display = "none";
				document.getElementById("penBalloon").style.display = "none";
				document.getElementById("figureBalloon").style.display = "none";
				document.getElementById("stampBalloon").style.display = "none";
				document.getElementById("textBalloon").style.display = "none";
				
				mode = "eraser";
			}
			
			if(doubleFlag == false)
			{
				doubleFlag = true;

				st = setInterval('timeout(true)', 300);
			}
			else
			{
				clearInterval(st);
				doubleFlag = false;

				var result = confirm('かいた線や画像をすべて削除します。よろしいですか。');

				//線と画像をすべて削除
				if(result)
				{
					paper.clear();
					objArray = [];
				}
			}
		}
		
		setPointerEvent();
	}
	catch(e)
	{
		//alert("modeChange:" + e.toString());
	}
}

function changeStampSelect(e)
{
	try
	{
		var id = $(e.currentTarget).attr("id");
		if(stampSelect != id)
		{
			$("#"+stampSelect).css("border", "1px solid #FFFFFF");
			$("#"+id).css("border", "1px solid #FF0000");
			
			stampSelect = id;
		}
	}
	catch(e)
	{
		alert("changeStampSelect:" + e.toString());
	}
}

function changeFigureSelect(e)
{
	try
	{
		var id = $(e.currentTarget).attr("id");
		
		if(figureSelect != id)
		{
			$("#"+figureSelect).css("border", "1px solid #FFFFFF");
			$("#"+id).css("border", "1px solid #FF0000");
			
			figureSelect = id;
		}
	}
	catch(e)
	{
		alert("changeFigureSelect:" + e.toString());
	}
}

function setPointerEvent()
{
	try
	{
		var modeArray = ["pen", "marker", "stamp", "figure", "text"];
		
		if(mode == "select")
		{
			if(drawConfig == true)
			{
				document.getElementById('svgCanvas').style.display='none';
			}
			else
			{
				document.getElementById('svgCanvas').style.pointerEvents = 'none';
			}
		}
		else
		{
			if(drawConfig == true)
			{
				document.getElementById('svgCanvas').style.display='block';
			}
			else
			{
				document.getElementById('svgCanvas').style.pointerEvents = 'auto';
			}
			
			var i;
			
			if(mode == "eraser")
			{
				for(i=0; i<modeArray.length; i++)
				{
					$('.' + modeArray[i] + "Svg").css('pointer-events', 'auto');
				}
			}
			else
			{
				for(i=0; i<modeArray.length; i++)
				{
					if(mode != modeArray[i])
					{
						$('.' + modeArray[i] + "Svg").css('pointer-events', 'none');
					}
					else
					{
						$('.' + modeArray[i] + "Svg").css('pointer-events', 'auto');
					}
				}
			}
		}
	}
	catch(e)
	{
		//alert("setPointerEvent:" + e.toString());
	}
}

function releaseToolHandler(f)
{
	try
	{
		if(mode == "pen" || mode == "marker")
		{
			if(f)
			{
				document.getElementById("drawBtn").src = "./img/draw-off.png";
			}
		}
		else if(mode == "figure")
		{
			if(f)
			{
				document.getElementById("figureBtn").src = "./img/figure-off.png";
			}
			
			changeSelectFigure(-1);
		}
		else if(mode == "stamp")
		{
			if(f)
			{
				document.getElementById("stampBtn").src = "./img/stamp-off.png";
			}
		}
		else if(mode == "text")
		{
			if(f)
			{
				document.getElementById("textBtn").src = "./img/text-off.png";
			}
			
			//入力の状態を解除
			if(document.getElementById("addInput").style.display == "block")
			{
				var s1 = document.getElementById("addInput").value;

				//入力が空とみなしてテキストを削除
				if(s1 == "" || s1.replace(/\s+/g, "") == "")
				{
					if(textIndex < objArray.length-1)
					{
						objArray[textIndex] = null;
						paper.getById("txt"+textIndex).remove();
					}
					else
					{
						paper.getById("txt" + (objArray.length-1)).remove();
						objArray.pop();
					}
				}
				//テキストの変更
				else
				{
					objArray[textIndex][3] = tColor;
					objArray[textIndex][4] = tSize;
					objArray[textIndex][5] = document.getElementById("addInput").value;

					paper.getById("txt" + textIndex).attr({"text": document.getElementById("addInput").value});
					paper.getById("txt" + textIndex).attr({"fill": colorArray[tColor]});
					paper.getById("txt" + textIndex).attr({"stroke": "none"});
					paper.getById("txt" + textIndex).attr({"font-size": tSizeArray[tSize]});

					paper.getById("txt" + textIndex).show();
				}

				document.getElementById("addInput").value = "";
				document.getElementById("addInput").style.display = "none";
			}
			//テキストの選択状態を解除
			else if(textIndex != -1)
			{
				paper.getById("txt" + textIndex).attr({"stroke":"none"});
			}

			textIndex = -1;
		}
		else if(mode == "eraser")
		{
			if(f)
			{
				document.getElementById("eraserBtn").src = "./img/eraser-off.png";
			}
		}
	}
	catch(e)
	{
		//alert("releaseToolHandler:" + e.toString());
	}
}

function addStampHandler()
{
	try
	{
		
	}
	catch(e)
	{
		//alert('addStampStart:' + e.toString());
	}
}


//svgCanvasに画像を追加
function addImageToSvgCanvas(num, src, px, py, sw, sh)
{
	try
	{
		var img = paper.image(src, px, py, sw, sh);
		
		img.id = 'img' + num;
		img.node.setAttribute('class', 'stampSvg');
		
		img.drag(
			//マウスムーブ
			function(dx, dy)
			{
				if(mode == 'stamp')
				{
					this.attr('x', this._x + dx);
					this.attr('y', this._y + dy);
				}
			},
			//マウスダウン
			function()
			{
				if(mode == 'stamp')
				{
					this._x = this.attr('x');
					this._y = this.attr('y');
				}
				else if(mode == 'figure')
				{
					changeSelectFigure(-1);
				}
				else if(mode == 'eraser')
				{
					this.remove();
				}
			},
			//マウスアップ
			function()
			{
				if(mode == 'stamp')
				{
					delete(this._x);
					delete(this._y);
					
					var n = parseInt(this.id.substring(3, this.id.length));
					
					objArray[n][2] = this.attr('x');
					objArray[n][3] = this.attr('y');
				}
			}
		);
	}
	catch(e)
	{
		alert('addImageToSvgCanvas:' + e.toString());
	}
}

function imageClear(img)
{
	img = null;
}

function timeout(f)
{
	try
	{
		clearInterval(st);
		doubleFlag = false;
	}
	catch(e)
	{
		//alert('timeout:' + e.toString());
	}
}

function changeText()
{
	clearInterval(st);
	doubleFlag = false;
}


function setFocus()
{
	document.getElementById("addInput").focus();
	document.getElementById("addInput").selectionStart = 0;
    document.getElementById("addInput").selectionEnd = 0;
	
	clearInterval(st);
}


var addFigure;
function addFigureStart(e)
{
	try
	{
		changeSelectFigure(-1);
		
		if(e.type == "touchstart")
		{
			if(e.targetTouches == undefined)
			{
				pX = e.originalEvent.targetTouches[0].pageX;
				pY = e.originalEvent.targetTouches[0].pageY;
			}
			else
			{
				pX = e.targetTouches[0].pageX;
				pY = e.targetTouches[0].pageY;
			}
		}
		else
		{
			pX = e.pageX;
			pY = e.pageY;
		}
		
		var str = e.currentTarget.id.substring(0, e.currentTarget.id.length-3);
		
		addFigure = createSvgElement(str);
		
		document.body.appendChild(addFigure);
		addFigure.id = str + 'Add';
		addFigure.style.position = 'absolute';
		addFigure.style.left = (pX - 20) + "px";
		addFigure.style.top = (pY - 20) + "px";
		
		
		if(ictMode)
		{
			$(document).on("mousemove touchmove", addFigureMove);
			$(document).on("mouseup touchend", addFigureStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchmove', addFigureMove);
			document.addEventListener('touchend', addFigureStop);
		}
		else
		{
			document.addEventListener('mousemove', addFigureMove);
			document.addEventListener('mouseup', addFigureStop);
		}
	}
	catch(e)
	{
		//alert('addFigureStart:' + e.toString());
	}
}

function addFigureMove(e)
{
	try
	{
		e.preventDefault();
		
		if(e.type == "touchmove")
		{
			if(e.targetTouches == undefined)
			{
				pX = e.originalEvent.targetTouches[0].pageX;
				pY = e.originalEvent.targetTouches[0].pageY;
			}
			else
			{
				pX = e.targetTouches[0].pageX;
				pY = e.targetTouches[0].pageY;
			}
		}
		else
		{
			pX = e.pageX;
			pY = e.pageY;
		}
		
		addFigure.style.left = (pX-20) + 'px';
		addFigure.style.top = (pY-20) + 'px';
	}
	catch(e)
	{
		//alert('addFigureMove:' + e.toString());
	}
}


function addFigureStop(e)
{
	try
	{
		var elm = document.getElementById('svgCanvas');
		var rect = elm.getBoundingClientRect();
		
		if(e.type == "touchend")
		{
			if(e.changedTouches == undefined)
			{
				pX = e.originalEvent.changedTouches[0].pageX - rect.left;
				pY = e.originalEvent.changedTouches[0].pageY;
			}
			else
			{
				pX = e.changedTouches[0].pageX - rect.left;
				pY = e.changedTouches[0].pageY;
			}
		}
		else if(e.type == "mouseup")
		{
			pX = e.pageX - rect.left;
			pY = e.pageY;
		}
		
		var str = addFigure.id.substring(0, addFigure.id.length-3);
		
		document.body.removeChild(addFigure);
		
		switch(str)
		{
			//点
			case "point":
				createPoint(objArray.length, pX, pY, true);
				objArray.push(['pnt', pX, pY]);
				break;
			
			//線分
			case "line":
				createLine(objArray.length, pX-15, pY-15, pX+15, pY+15, true);
				objArray.push(['lin', pX-15, pY-15, pX+15, pY+15]);
				break;
			
			//円
			case "circle":
				createCircle(objArray.length, pX, pY, pX+15, pY, true);
				objArray.push(['cir', pX, pY, pX+15, pY]);
				break;
			
			//正方形
			case "square":
				createSquare(objArray.length, pX, pY, pX-15, pY-15, true);
				objArray.push(['sqr', pX, pY, pX-15, pY-15]);
				break;
			
			//四角形
			case "rectangle":
				var pntArray = [[pX-15, pY-10], [pX-15, pY+10], [pX+15, pY+10], [pX+15, pY-10]];
				createRectangle(objArray.length, pntArray, true);
				objArray.push(['rct', pntArray]);
				break;
			
			//正三角形
			case "eqTriangle":
				createEqTriangle(objArray.length, pX, pY+3, pX, pY+3-16/Math.cos(15*Math.PI/180), true);
				objArray.push(['eqt', pX, pY+3, pX, pY+3-16/Math.cos(15*Math.PI/180)]);
				break;
			
			//三角形
			case "triangle":
				var pntArray = [[pX-5, pY-15], [pX-15, pY+10], [pX+15, pY+15]];
				createTriangle(objArray.length, pntArray, true);
				objArray.push(['tri', pntArray]);
				break;
		}
		
		if(ictMode)
		{
			$(document).off('mousemove touchmove', addFigureMove);
			$(document).off('mouseup touchend', addFigureStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchmove', addFigureMove);
			document.removeEventListener('touchend', addFigureStop);
		}
		else
		{
			document.removeEventListener('mousemove', addFigureMove);
			document.removeEventListener('mouseup', addFigureStop);
		}
	}
	catch(e)
	{
		//alert('addFigureMove:' + e.toString());
	}
}


function createSvgElement(str)
{
	try
	{
		var NS = 'http://www.w3.org/2000/svg';
		var svg = document.createElementNS(NS, 'svg');
		svg.setAttribute('viewBox', '0 0 40 40');
		svg.style.width = '40px';
		svg.style.height = '40px';
		svg.style.zIndex = '999';
		
		svg.innerHTML += '<rect x="0" y="0" width="40" height="40" fill="#FFFFFF" fill-opacity="0" />';
		
		switch(str)
		{
			case 'point':
				svg.innerHTML += '<circle cx="20" cy="20" r="4" fill="#000000" />';
				break;
				
			case 'line':
				svg.innerHTML += '<line x1="5" y1="5" x2="35" y2="35" stroke="#000000" stroke-width="1" />';
				break;
			
			case 'circle':
				svg.innerHTML += '<circle cx="20" cy="20" r="15" stroke="#000000" stroke-width="1" fill="#FFFFFF" fill-opacity="0" />';
				break;
			
			case 'square':
				svg.innerHTML += '<rect x="5" y="5" width="30" height="30" stroke="#000000" stroke-width="1" fill="#FFFFFF" fill-opacity="0" />';
				break;
			
			case 'rectangle':
				svg.innerHTML += '<rect x="5" y="10" width="30" height="20" stroke="#000000" stroke-width="1" fill="#FFFFFF" fill-opacity="0" />';
				break;
			
			case 'eqTriangle':
				svg.innerHTML += '<path d="M20,7L5,33L35,33L20,7" x4="" stroke="#000000" stroke-width="1" fill="#FFFFFF" fill-opacity="0" />';
				break;
			
			case 'triangle':
				svg.innerHTML += '<path d="M15,5L5,30L35,35L15,5" x4="" stroke="#000000" stroke-width="1" fill="#FFFFFF" fill-opacity="0" />';
				break;
		}
			
		return svg;
	}
	catch(e)
	{
		//alert('createSvgElement:'+e.toString());
	}
}

function drawStart(e)
{
	try
	{
		e.preventDefault();
		
		var elm = document.getElementById('svgCanvas');
		var rect = elm.getBoundingClientRect();
			
		if(e.type == "touchstart")
		{
			if(e.targetTouches != undefined)
			{
				pX = e.targetTouches[0].pageX - rect.left;
				pY = e.targetTouches[0].pageY;
			}
			else
			{
				pX = e.originalEvent.targetTouches[0].pageX - rect.left;
				pY = e.originalEvent.targetTouches[0].pageY;
			}
		}
		else
		{
			pX = e.pageX - rect.left;
			pY = e.pageY;
		}
		
		if(mode == 'pen' || mode == 'marker')
		{
			dFlag = false;
			
			if(mode == 'pen')
			{
				var penName = 'pen' + objArray.length;
				
				objArray[objArray.length] = ['pen', 'M'+pX+','+pY, pColor, pSize, pAlpha];
			}
			else if(mode == 'marker')
			{
				var markerName = 'mar' + objArray.length;
				
				objArray[objArray.length] = ['mar', 'M'+pX+','+pY, mColor, mSize, mAlpha];
			}
			
			if(e.type == "pointerdown")
			{
				$(document).on('pointermove', drawMove);
				$(document).on('pointerup', drawStop);
			}
			else
			{
				$(document).on('touchmove mousemove', drawMove);
				$(document).on('touchend mouseup', drawStop);
			}
		}
		else if(mode == 'figure')
		{
			if(e.target == "[object SVGSVGElement]")
			{
				//選択解除
				if(figureNum != -1)
				{
					changeSelectFigure(-1);
				}
				else
				{
					figureNum = objArray.length;
					
					switch(figureSelect)
					{
						//点
						case "pointSvg":
							createPoint(objArray.length, pX, pY, true);
							objArray.push(['pnt', pX, pY]);
							break;

						//線分
						case "lineSvg":
							createLine(objArray.length, pX-15, pY-15, pX+15, pY+15, true);
							objArray.push(['lin', pX-15, pY-15, pX+15, pY+15]);
							break;

						//円
						case "circleSvg":
							createCircle(objArray.length, pX, pY, pX+15, pY, true);
							objArray.push(['cir', pX, pY, pX+15, pY]);
							break;

						//正方形
						case "squareSvg":
							createSquare(objArray.length, pX, pY, pX-15, pY-15, true);
							objArray.push(['sqr', pX, pY, pX-15, pY-15]);
							break;

						//四角形
						case "rectangleSvg":
							var pntArray = [[pX-15, pY-10], [pX-15, pY+10], [pX+15, pY+10], [pX+15, pY-10]];
							createRectangle(objArray.length, pntArray, true);
							objArray.push(['rct', pntArray]);
							break;

						//正三角形
						case "eqTriangleSvg":
							createEqTriangle(objArray.length, pX, pY+3, pX, pY+3-16/Math.cos(15*Math.PI/180), true);
							objArray.push(['eqt', pX, pY+3, pX, pY+3-16/Math.cos(15*Math.PI/180)]);
							break;

						//三角形
						case "triangleSvg":
							var pntArray = [[pX-5, pY-15], [pX-15, pY+10], [pX+15, pY+15]];
							createTriangle(objArray.length, pntArray, true);
							objArray.push(['tri', pntArray]);
							break;
					}
				}
			}
		}
		//スタンプ
		else if(mode == "stamp")
		{
			if(e.target == "[object SVGSVGElement]")
			{
				var src = "./img/"+stampSelect+".png";

				objArray[objArray.length] = ['img', src, pX-20, pY-20];

				//svg領域に画像を追加
				addImageToSvgCanvas(objArray.length-1, src, pX-20, pY-20, 40, 40);
			}
		}
	}
	catch(e)
	{
		alert('drawStart:' + e.toString());
	}
}

function drawMove(e)
{
	try
	{
		if(mode == 'pen' || mode == 'marker')
		{
			e.preventDefault();
			
			dFlag = true;
			
			var elm = document.getElementById('svgCanvas');
			var rect = elm.getBoundingClientRect();
			
			var nX;
			var nY;
			
			if(e.type == "touchmove")
			{
				if(e.changedTouches != undefined)
				{
					nX = e.changedTouches[0].pageX - rect.left;
					nY = e.changedTouches[0].pageY;
				}
				else
				{
					nX = e.originalEvent.changedTouches[0].pageX - rect.left;
					nY = e.originalEvent.changedTouches[0].pageY;
				}
			}
			else
			{
				nX = e.pageX - rect.left;
				nY = e.pageY;
			}
			
			var path;
			
			if(mode == 'pen')
			{
				if(paper.getById('pen'+(objArray.length-1).toString()) == null)
				{
					path = paper.path('M'+pX+','+pY);
					path.id = 'pen' + (objArray.length-1);
				}
				else
				{
					path = paper.getById('pen'+(objArray.length-1).toString());
				}
				
				objArray[objArray.length-1][1] = objArray[objArray.length-1][1]+'L'+nX+','+nY;
				
				redrawLine(path, true, objArray[objArray.length-1][1], objArray[objArray.length-1][2], objArray[objArray.length-1][3], objArray[objArray.length-1][4]);
			}
			else if(mode == 'marker')
			{
				if(paper.getById('mar'+(objArray.length-1).toString()) == null)
				{
					path = paper.path('M'+pX+','+pY);
					path.id = 'mar' + (objArray.length-1);
				}
				else
				{
					path = paper.getById('mar'+(objArray.length-1).toString());
				}
				
				var str = objArray[objArray.length-1][1];
				
				if(str.indexOf('L') != -1)
				{
					str = str.substring(0, str.indexOf('L'));
				}
				
				var r = Math.atan2(nY - pY, nX - pX) * 180/Math.PI;
				
				str = str + 'L' +nX+','+nY;
				
				objArray[objArray.length-1][1] = str;
				
				redrawLine(path, false, objArray[objArray.length-1][1], objArray[objArray.length-1][2], objArray[objArray.length-1][3], objArray[objArray.length-1][4]);
			}
			
			
		}
	}
	catch(e)
	{
		//alert('drawMove:' + e.toString());
	}
}

function redrawLine(path, f, str, color, w, op)
{
	
	var name = path.id;
	path.remove();
	
	//線の描画
	drawSvgLine(path, f, name, str, color, w, op);
}

//
function drawSvgLine(path, f, name, str, color, w, op)
{
	try
	{
		path = paper.path(str);
		path.id = name;
		
		if(f)
		{
			path.node.setAttribute('class', 'penSvg');
			
			path.attr(
				{
					'stroke-linecap':'round',
					'stroke-linejoin':'round',
					'stroke':colorArray[color],
					'stroke-width':pSizeArray[w],
					'stroke-opacity':alphaArray[op]
				}
			);
		}
		else
		{
			path.node.setAttribute('class', 'markerSvg');
			
			path.attr(
				{
					'stroke-linecap':'butt',
					'stroke':colorArray[color],
					'stroke-width':mSizeArray[w],
					'stroke-opacity':alphaArray[op]						
				}
			);
		}
	}
	catch(e)
	{
		//alert('svgDrawLine:' + e.toString());	
	}
}

//削除選択のために見た目の線よりも太い線をかぶせて削除の判定にする
function setTouchEvent(f, num)
{
	try
	{
		//自由線
		//削除用の線を設定して自由線の上にかぶせる
		if(f)
		{
			var path = paper.path(objArray[num][1]);
			path.node.setAttribute('class', 'penSvg');
			
			var tw;
			
			if(pSizeArray[objArray[num][3]] < 20)
			{
				tw = 20;
			}
			else
			{
				tw = pSizeArray[objArray[num][3]];
			}
			
			path.attr(
					{
						'stroke-linecap':'round',
						'stroke-linejoin':'round',
						'stroke':'#FF0000',
						'stroke-width':tw,
						'stroke-opacity':0					
					}
				);
			
			path.id = 'tch'+num;
		
			path.mousedown(
				function(e)
				{
					try
					{
						var n = parseInt(this.id.substring(3, this.id.length));
						
						//データと線を削除
						if(mode == 'eraser')
						{
							paper.getById('pen'+n).remove();
							
							objArray[n] = null;
							
							this.remove();
						}
						else if(mode == "figure")
						{
							changeSelectFigure(-1);
						}
					}
					catch(e)
					{
						//alert('tch:' + e.toString());	
					}
				}
			);
		}
		//マーカー
		else
		{
			//データと線を削除
			paper.getById('mar'+num).mousedown(
				function(e)
				{
					var i = parseInt(this.id.substring(3, this.id.length));
					
					if(mode == 'figure')
					{
						changeSelectFigure(-1);
					}
					else if(mode == 'eraser')
					{
						objArray[i] = null;
						this.remove();
					}
				}
			);
		}
	}
	catch(e)
	{
		//alert('setTouchEvent:' + e.toString());
	}
}


function drawStop(e)
{
	try
	{
		if(mode == 'pen' || mode == 'marker')
		{
			if(dFlag == false)
			{
				objArray[objArray.length-1] = null;
			}
			else
			{
				//削除の設定
				if(mode == 'pen')
				{
					setTouchEvent(true, objArray.length-1);
				}
				else
				{
					setTouchEvent(false, objArray.length-1);
				}
			}
		}
		
		if(e.type =="pointerup")
		{
			$(document).off('pointermove', drawMove);
			$(document).off('pointerup', drawStop);
		}
		else
		{
			$(document).off('touchmove mousemove', drawMove);
			$(document).off('touchend mouseup', drawStop);
		}
		/*
		else if(mFlag)
		{
			document.getElementById('svgCanvas').removeEventListener('touchmove', drawMove);
			document.removeEventListener('touchend', drawStop);
		}
		else
		{
			document.getElementById('svgCanvas').removeEventListener('mousemove', drawMove);
			document.removeEventListener('mouseup', drawStop);
		}
		*/
	}
	catch(e)
	{
		//alert('drawStop:' + e.toString());
	}
}

function setTextHandler(e)
{
	try
	{
		if(mode == "text")
		{
			var rect = document.getElementById('svgCanvas').getBoundingClientRect();
			var nX;
			var nY;
			
			if(e.type == "touchstart")
			{
				if(e.targetTouches == undefined)
				{
					nX = e.originalEvent.targetTouches[0].pageX - rect.left;
					nY = e.originalEvent.targetTouches[0].pageY;
				}
				else
				{
					nX = e.targetTouches[0].pageX - rect.left;
					nY = e.targetTouches[0].pageY;
				}
			}
			else if(e.type == "mousedown")
			{
				nX = e.pageX - rect.left;
				nY = e.pageY;
			}
			
			//テキスト入力が表示されている場合
			if(document.getElementById("addInput").style.display == "block")
			{
				var str = document.getElementById("addInput").value;
				
				//入力が空とみなしてテキストを削除
				if(str == "" || str.replace(/\s+/g, "") == "")
				{
					if(textIndex < objArray.length-1)
					{
						objArray[textIndex] = null;
						paper.getById("txt"+textIndex).remove();
					}
					else
					{
						paper.getById("txt" + (objArray.length-1)).remove();
						objArray.pop();
					}
				}
				//テキストの変更
				else
				{
					objArray[textIndex][3] = tColor;
					objArray[textIndex][4] = tSize;
					objArray[textIndex][5] = document.getElementById("addInput").value;
				
					paper.getById("txt" + textIndex).attr({"text": document.getElementById("addInput").value});
					paper.getById("txt" + textIndex).attr({"fill": colorArray[tColor]});
					paper.getById("txt" + textIndex).attr({"stroke": "none"});
					paper.getById("txt" + textIndex).attr({"font-size": tSizeArray[tSize]});
					
					paper.getById("txt" + textIndex).show();
				}
				
				textIndex = -1;
				
				document.getElementById("addInput").value = "";
				document.getElementById("addInput").style.display = "none";
			}
			//テキストの作成、設定
			else
			{
				//テキストの選択
				if(e.target.parentNode == "[object SVGTextElement]")
				{
					var idStr = e.target.parentNode.id;
					
					//別のテキストが選択されていた場合、選択を解除
					if(textIndex !=  parseInt(idStr.substring(3, idStr.length)) && textIndex != -1)
					{
						paper.getById("txt" + textIndex).attr({"stroke":"none"});
					}
					
					textIndex = parseInt(idStr.substring(3, idStr.length));
					
					paper.getById('txt' + textIndex).attr({"stroke":colorArray[objArray[textIndex][3]]});
					
					//色
					if(tColor != objArray[textIndex][3])
					{
						document.getElementById("tColor"+tColor).style.border = "1px #000000 solid";
						document.getElementById("tColor"+objArray[textIndex][3]).style.border = "1px #FF0000 solid";
						tColor = objArray[textIndex][3];
					}
					
					//大きさ
					if(tSize != objArray[textIndex][4])
					{
						document.getElementById("tSize"+tSize).style.border = "1px #000000 solid";
						document.getElementById("tSize"+objArray[textIndex][4]).style.border = "1px #FF0000 solid";
						tSize = objArray[textIndex][4];
					}
					
					if(doubleFlag == false)
					{
						doubleFlag = true;
						st = setInterval('changeText()', 300);
						
						//マウスとテキストの相対座標
						pX = objArray[textIndex][1] - nX;
						pY = objArray[textIndex][2] - nY;
						
						//ドラッグイベント追加
						if(ictMode)
						{
							$(document).on("mousemove touchmove", textDragMove);
							$(document).on("mouseup touchend", textDragStop);
						}
						else if(mFlag)
						{
							document.addEventListener("touchmove", textDragMove);
							document.addEventListener("touchend", textDragStop);
						}
						else
						{
							document.addEventListener("mousemove", textDragMove);
							document.addEventListener("mouseup", textDragStop);
						}
					}
					//テキストの編集
					else
					{
						//ドラッグイベント削除
						if(ictMode)
						{
							$(document).off("mousemove touchmove", textDragMove);
							$(document).off("mouseup touchend", textDragStop);
						}
						else if(mFlag)
						{
							document.removeEventListener("touchmove", textDragMove);
							document.removeEventListener("touchend", textDragStop);
						}
						else
						{
							document.removeEventListener("mousemove", textDragMove);
							document.removeEventListener("mouseup", textDragStop);
						}
						
						doubleFlag = false;
						clearInterval(st);
						
						paper.getById("txt" + textIndex).hide();
						
						document.getElementById("addInput").style.display = "block";
						document.getElementById("addInput").value = "";
						
						var tx = objArray[textIndex][1];
						var ty = objArray[textIndex][2];
						var tc = objArray[textIndex][3];
						var ts = objArray[textIndex][4];
						var tv = objArray[textIndex][5];
						
						document.getElementById("addInput").style.color = colorArray[tc];
						document.getElementById("addInput").style.fontSize = tSizeArray[ts] + "px";
						document.getElementById("addInput").style.left = (tx-5) + "px";
						document.getElementById("addInput").style.top = (ty-5-tSizeArray[ts]/2) + "px";
						
						document.getElementById("addInput").value = tv;
						
						document.getElementById("addInput").focus();
						st = setInterval('setFocus()', 300);
					}
				}
				//選択解除
				else if(textIndex != -1)
				{
					paper.getById('txt' + textIndex).attr({"stroke":"none"});
					
					textIndex = -1;
				}
				//新規にテキストを追加
				else
				{
					document.getElementById("addInput").style.display = "block";
					document.getElementById("addInput").value = "";
					
					document.getElementById("addInput").style.color = colorArray[tColor];
					document.getElementById("addInput").style.fontSize = tSizeArray[tSize] + "px";
					document.getElementById("addInput").style.left = (nX-5) + "px";
					document.getElementById("addInput").style.top = (nY-5-tSizeArray[tSize]/2) + "px";
					
					document.getElementById("addInput").focus();
					st = setInterval('setFocus()', 300);
					
					createText(objArray.length, nX, nY, tColor, tSize, "");
					
					textIndex = objArray.length;
					
					objArray.push(["txt", nX, nY, tColor, tSize, ""]);
				}
			}
		}
	}
	catch(e)
	{
		//alert("setTextHandler:" + e.toString());
	}
}

function createText(num, nX, nY, color, size, str)
{
	try
	{
		var t = paper.text(nX, nY, str).attr({"font-family":defFont, "fill":colorArray[color], "stroke":"none", "font-size":tSizeArray[size], 'text-anchor': 'start'});
		t.id = "txt" + num;
		
		t.node.setAttribute('class', 'textSvg');
		t.node.setAttribute('id', 'txt' + num);
		
		//削除用イベント追加
		t.mousedown(
			function(e)
			{
				if(mode == "eraser")
				{
					var id = parseInt(this.id.substring(3, this.id.length));
					
					objArray[id] = null;
					
					this.remove();
				}
			}
		);
	}
	catch(e)
	{
		//alert("createText:" + e.toString());
	}
}


function textDragMove(e)
{
	try
	{
		e.preventDefault();
		
		var rect = document.getElementById('svgCanvas').getBoundingClientRect();
		var tX;
		var tY;
		
		if(e.type == "touchmove")
		{
			if(e.targetTouches == undefined)
			{
				tX = e.originalEvent.targetTouches[0].pageX - rect.left;
				tY = e.originalEvent.targetTouches[0].pageY;
			}
			else
			{
				tX = e.targetTouches[0].pageX - rect.left;
				tY = e.targetTouches[0].pageY;
			}
		}
		else if(e.type == "mousemove")
		{
			tX = e.pageX - rect.left;
			tY = e.pageY;
		}
		
		paper.getById("txt" + textIndex).attr({x:tX+pX, y:tY+pY});
		objArray[textIndex][1] = tX+pX;
		objArray[textIndex][2] = tY+pY;
	}
	catch(e)
	{
		//alert("textDragMove:" + e.toString());
	}
}

function textDragStop(e)
{
	try
	{
		//ドラッグイベント追加
		if(ictMode)
		{
			$(document).off("mousemove touchmove", textDragMove);
			$(document).off("mouseup touchend", textDragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener("touchmove", textDragMove);
			document.removeEventListener("touchend", textDragStop);
		}
		else
		{
			document.removeEventListener("mousemove", textDragMove);
			document.removeEventListener("mouseup", textDragStop);
		}
	}
	catch(e)
	{
		//alert("textDragStop:" + e.toString());
	}
}


function toolPositionChange(e)
{
	try
	{
		changeToolPosition();
	}
	catch(e)
	{
		//alert("toolPositionChange:" + e.toString());
	}
}

function changeToolPosition()
{
	try
	{
		var y;
		if (navigator.userAgent.indexOf('WebKit') < 0)
		{
			y = document.documentElement.scrollTop;
		}
		else
		{
			y = document.body.scrollTop;
		}
		
		document.getElementById('penBalloon').style.top = (y + 10) + 'px';
		
		//データ操作表示
		if(document.getElementById("dataConfigBtn").style.display == "inline")
		{
			document.getElementById('dataBalloon').style.top = (y + 10) + 'px';
			document.getElementById('figureBalloon').style.top = (y + 95) + 'px';
			document.getElementById('stampBalloon').style.top = (y + 82) + 'px';
			document.getElementById('textBalloon').style.top = (y + 65) + 'px';
		}
		//非表示
		else
		{
			document.getElementById('figureBalloon').style.top = (y + 40) + 'px';
			document.getElementById('stampBalloon').style.top = (y + 25) + 'px';
			document.getElementById('textBalloon').style.top = (y + 10) + 'px';
		}
		
		if($('#modalBlock').css('display') == 'block')
		{
			modalDisplayChange();
		}
	}
	catch(e)
	{
		//alert("changeToolPosition:" + e.toString());
	}
}

function windowResize(e)
{
	modalDisplayChange();
}

function modalDisplayChange()
{
	try
	{
		document.getElementById("modalBlock").style.width = "100%";
		
		var wW;
		var ua = navigator.userAgent.toLowerCase();
		
		if(ua.indexOf("ipad") != -1 || ua.indexOf("iphone") != -1 || ua.indexOf("android") != -1)
		{
			wW = $("body").width();
			
			document.getElementById('modalBlock').style.width = wW +"px";
		}
		else
		{
			wW = $(window).width();
		}
		
		var wH = $("#main").innerHeight();
		
		if(wH < window.innerHeight)
		{
			wH = window.innerHeight;
		}
		
		document.getElementById('modalBlock').style.height = wH + "px";
		
		var target = null;
		var elms = $('#modalInner').children('div');
		
		for(var i=0; i<elms.length; i++)
		{
			if(elms[i].style.display != 'none')
			{
				target = $(elms[i]);
				break;
			}
		}
		
		if(target == null)
		{
			return;
		}
		
		var iW = target.width();
		var iH = target.height();
		
		
		var y;
		if (navigator.userAgent.indexOf('WebKit') < 0)
		{
			y = document.documentElement.scrollTop;
		}
		else
		{
			y = document.body.scrollTop;
		}
		
		var mTop = (window.innerHeight - iH)/2 + y;
		
		var mLeft = (wW - iW)/2;
		
		$('#modalInner').css('top', mTop);
		$('#modalInner').css('left', mLeft);
	}
	catch(e)
	{
		//alert("modalDisplayChange:" + e.toString());
	}
}

function setModal(str)
{
	try
	{
		$('#modalInner').append($('#'+str));
		
		var n = 1000 + $('#modalInner').children('div').length;
		
		$('#'+str).css('z-index', n);
		
		$('#'+str).css('display', 'inline-block');
		
		modalDisplayChange();
	}
	catch(e)
	{
		//alert('setModal:' + e.toString());
	}
}

function showModal(str)
{
	try
	{
		var elm = $('#modalInner').children('div');
		
		for(var i=0; i<elm.length; i++)
		{
			if(elm[i].id == str)
			{
				elm[i].style.display = 'inline-block';
			}
			else
			{
				elm[i].style.display = 'none';
			}
		}
		
		document.getElementById('modalBlock').style.display = 'block';
		
		modalDisplayChange();
	}
	catch(e)
	{
		//alert("showModal:" + e.toString());
	}
}

function closeModal()
{
	try
	{
		document.getElementById('modalBlock').style.display = 'none';
	}
	catch(e)
	{
		alert("closeModal" + e.toString());
	}
}

function closeModalOutsideHandler(e)
{
	try
	{
		if(e.target.id == "modalBlock")
		{
			closeModal();
		}
	}
	catch(e)
	{
		alert("closeModalOutsideHandler:" + e.toString());
	}
}

function mouseDownModalOut(e)
{
	try
	{
		if(e.target.id == "modalBlock" && document.getElementById("helpBlock").style.display == "inline-block")
		{
			closeModal("helpBlock");
		}
	}
	catch(e)
	{
		//alert("mouseDownModalOut:"+e.toString());
	}
}

function openConfigHandler(e)
{
	try
	{
		if($("#configBalloon").css("display") == "none")
		{
			$("#configBalloon").css("display", "inline-block");
			
			changeConfigBalloonPosition();
		}
		else
		{
			$("#configBalloon").css("display", "none");
			
			if($("#selectBalloon_config") != null)
			{
				$("#selectBalloon_config").css("display", "none");
			}
		}
	}
	catch(e)
	{
		alert("openCofigHandler:" + e.toString());
	}
}

function changeConfigBalloonPosition()
{
	try
	{
		$("#configBalloon").css("right", "35px");
	}
	catch(e)
	{
		alert("changeConfigBalloonPosition:" + e.toString());
	}
}

function saveHandler(e)
{
	try
	{
		//アニメーション中は実行しない
		if(typeof animeFlag != "undefined" && animeFlag == true)
		{
			return;
		}
		
		var saveArray = new Array();
		
		saveArray[0] = contentID;
		saveArray[1] = objArray.slice();
		saveArray[2] = saveContent();
		
		if(document.getElementById("zoomIn").style.display != "none")
		{
			saveArray[3] = [];
			saveArray[3][0] = cScale;
			
			var leftNum = document.getElementById("graphCanvas").style.left;
			var topNum = document.getElementById("graphCanvas").style.top;
			
			saveArray[3][1] = parseInt(leftNum.substring(0, leftNum.length-2));
			saveArray[3][2] = parseInt(topNum.substring(0, topNum.length-2));
		}
		
		var str = JSON.stringify(saveArray);
		
		var fileName = contentID + "-" + getDateString();
		var blob;
		
		if(navigator.userAgent.indexOf('iPad') != -1 || navigator.userAgent.indexOf('iPod') != -1 || navigator.userAgent.indexOf('iPhone') != -1)
		{
			var imgData = encimg(str);
			
			var bin = atob(imgData.split(',')[1]);
			
			// 空の Uint8Array ビューを作る
			var buffer = new Uint8Array(bin.length);
			
			// Uint8Array ビューに 1 バイトずつ値を埋める
			for (var i = 0; i < bin.length; i++)
			{
				buffer[i] = bin.charCodeAt(i);
			}
			
			blob = new Blob([buffer], {"type" : "image/png"});
			
			document.getElementById("saveFile").setAttribute('download', fileName+".png");
			
			if(window.navigator.msSaveBlob)
			{
				window.navigator.msSaveBlob(blob, contentID+".png"); 
	
				// msSaveOrOpenBlobの場合はファイルを保存せずに開ける
				window.navigator.msSaveOrOpenBlob(blob, contentID+".png"); 
			}
			else
			{
				document.getElementById("saveFile").href = window.URL.createObjectURL(blob);
			}
		}
		else
		{
			blob = new Blob([str], { "type" : "text/plain" });
			
			document.getElementById("saveFile").setAttribute('download', fileName+".dat");
			
			if(window.navigator.msSaveBlob)
			{ 
				window.navigator.msSaveBlob(blob, contentID+".dat"); 
	
				// msSaveOrOpenBlobの場合はファイルを保存せずに開ける
				window.navigator.msSaveOrOpenBlob(blob, contentID+".dat"); 
			}
			else
			{
				 document.getElementById("saveFile").href = window.URL.createObjectURL(blob);
			}
		}
	}
	catch(e)
	{
		//alert('saveFnc' + e.toString());
	}
}


//データの読み込み
function changeFile(event)
{
	try
	{
		//アニメーション中は実行しない
		if(typeof animeFlag != "undefined" && animeFlag == true)
		{
			return;
		}
		
		if(event.target.files.length == 0)
		{
			return;
		}
		
		var file = event.target.files[0];
		var reader = new FileReader();
		
		var f;
		//画像データの場合
		if(file.name.lastIndexOf('.png') == file.name.length-4 || file.name.lastIndexOf('.PNG') == file.name.length-4)
		{
			f = true;
		}
		else
		{
			f = false;
		}
		
		reader.onload = function(e)
		{
			var str = e.target.result;
			
			//画像データの読み込み
			if(f)
			{
				var img = new Image();
				
				img.onload = function()
				{
					var data = decimg(img);
					loadData(data);
				}
				
				img.src = str;
			}
			//テキストデータの読み込み
			else
			{
				loadData(str);
			}
			
			$('#file_input').val('');
		}
		
		reader.onError = function(e)
		{
			alert("データの読み込みでエラーが発生しました。");
			
			$('#file_input').val('');
		}
		
		if(f)
		{
			reader.readAsDataURL(file);
		}
		else
		{
			reader.readAsText(file);
		}
	}
	catch(e)
	{
		//alert('loadHandler:' + e.toString());
	}
}

function setHelp()
{
	try
	{
		//ヘルプの表示
		document.getElementById("helpBtn").addEventListener("click", openHelpHandler);
		
		//ズームがある場合は読み込む画像を変更
		if(document.getElementById("zoomIn").style.display == "inline")
		{
			document.getElementById("imgTool").src = "./img/help/toolWithZoom.png";
		}
		
		//ヘルプの画像
		document.getElementById("imgContent").src ="./img/help/"+contentID+".png";
		
		
		if(ictMode)
		{
			$("#imgContent").width(700);
			$("#imgContent").height("auto");
			
			$("#imgTool").width(700);
			$("#imgTool").height("auto");
		}
		else
		{
			$("#imgContent").width(800);
			$("#imgContent").height("auto");
			
			$("#imgTool").width(800);
			$("#imgTool").height("auto");
		}
		
		
		//ヘルプウィンドウのタブ
		document.getElementById("helpClose").addEventListener("click", closeHelpHandler);
		document.getElementById("helpContent").addEventListener("click", changeHelpHandler);
		document.getElementById("helpTool").addEventListener("click", changeHelpHandler);
		
		
		document.getElementById("modalBlock").addEventListener('mousedown', mouseDownModalOut);
		document.getElementById("modalBlock").addEventListener('touchstart', mouseDownModalOut);
		
		
		setModal("helpBlock");
		
		changeHelp(true);
	}
	catch(e)
	{
		//alert("setHelp:" + e.toString());
	}
}


function openHelpHandler(e)
{
	try
	{
		showModal("helpBlock");
		
		modalDisplayChange();
	}
	catch(e)
	{
		//alert("openHelpHandler:" + e.toString());
	}
}

//
function getRadiusHtml(r, f)
{
	try
	{
		var str = "";
		
		if(f)
		{
			if(r == 0)
			{
				str = "0";
			}
			else if(r == 180)
			{
				str = '<span class="times">π</span>';
			}
			else
			{
				str = r.toString()+"/180";
				
				
				str = math.simplify(str).toString();
				
				//空白削除
				str = str.replace(/\s+/g, "");

				if(str.substring(0,2) == "1/")
				{
					str = '<span class="times">π</span>' + str.substring(1, str.length);
				}
				else if(str.substring(0,3) == "-1/")
				{
					str = '-<span class="times">π</span>' + str.substring(2, str.length);
				}
				//
				else if(str.indexOf("/") != -1)
				{
					str = str.substring(0, str.indexOf("/")) + '<span class="times">π</span>' + str.substring(str.indexOf("/"), str.length);
				}
				else 
				{
					str = str + '<span class="times">π</span>';
				}
			}
		}
		else
		{
			str = r.toString() + "°";
		}
		
		return str;
	}
	catch(e)
	{
		alert("getRadiusHtml:" + e.toString());
	}
}

//MathJax用の角度を表す文字列の取得
function getRadiusTex(r, f)
{
	try
	{
		var str = "";
		
		//弧度法
		if(f)
		{
			if(r == 0)
			{
				str = "0";
			}
			else if(r == 180)
			{
				str = "π";
			}
			else
			{
				str = r.toString()+"/180";
				str = math.simplify(str).toString();
				
				//空白削除
				str = str.replace(/\s+/g, "");
				
				if(str.substring(0,2) == "1/")
				{
					str = "π" + str.substring(1, str.length);
				}
				//
				else if(str.indexOf("/") != -1)
				{
					str = str.substring(0, str.indexOf("/")) + "π" + str.substring(str.indexOf("/"), str.length);
				}
				else 
				{
					str = str + "π";
				}
				
				str = str.replace("π", "\pi");
				
				//空白削除
				str = str.replace(/\s+/g, "");
			}
			
			str = math.parse(str).toTex({parenthesis:'keep'});
		}
		//度数法
		else
		{
			str = math.parse(r).toTex({parenthesis:'keep'}) + "^\\circ";
		}
		
		return str;
	}
	catch(e)
	{
		alert("getRadiusTex:" + e.toString());
	}
}

//Mathjaxを変更
function changeMathJax(id, str, f)
{

	try
	{
		var elem = MathJax.Hub.getAllJax(id)[0];
		
		if(str != "")
		{
			var latex;
			
			//parseとTex変換する場合
			if(f)
			{
				var node = math.parse(str);

				latex = node ? node.toTex({parenthesis:'keep', implicit:'hide'}) : '';
				MathJax.Hub.Queue(['Text', elem, latex]);
			}
			//直接Latexが送られた場合(度数法の角度表記などで使用)
			else
			{
				MathJax.Hub.Queue(['Text', elem, str]);
			}
			
			return true;
		}
		else
		{
			MathJax.Hub.Queue(['Text', elem, '']);
			return true;
		}
	}
	catch(e)
	{
		return false;
	}
}

function closeHelpHandler(e)
{
	try
	{
		closeModal("helpBlock");
	}
	catch(e)
	{
		//alert("closeHelpHandler:" + e.toString());
	}
}

function changeHelpHandler(e)
{
	try
	{
		if(e.target.id == "helpContent")
		{
			changeHelp(true);
		}
		else
		{
			changeHelp(false);
		}
		
		modalDisplayChange();
	}
	catch(e)
	{
		//alert("changeHelpHandler:" +e.toString());
	}
}

function changeHelp(f)
{
	try
	{
		if(f)
		{
			document.getElementById("imgContent").style.display = "inline";
			document.getElementById("imgTool").style.display = "none";
			
			document.getElementById("helpContent").src ="./img/helpContent_on.png";
			document.getElementById("helpTool").src ="./img/helpTool_off.png";
			
			document.getElementById("helpContent").style.cursor = "default";
			document.getElementById("helpTool").style.cursor = "pointer";
		}
		else
		{
			document.getElementById("imgContent").style.display = "none";
			document.getElementById("imgTool").style.display = "inline";
			
			document.getElementById("helpContent").src ="./img/helpContent_off.png";
			document.getElementById("helpTool").src ="./img/helpTool_on.png";
			
			document.getElementById("helpContent").style.cursor = "pointer";
			document.getElementById("helpTool").style.cursor = "default";
		}
	}
	catch(e)
	{
		//alert("changeHelp:" + e.toString());
	}
}



//バージョンチェック
function checkVersionHandler(vStr)
{
	try
	{
		return;
		
		contentVersion = vStr;
		
		//接続確認用画像を読み込む
		var img = new Image();
		
		checkURL = "https://ten.tokyo-shoseki.co.jp/support/kou/tm/sugaku/d_meister_29/new/versionCheck2/versionCheck.html";
		
		
		img.onload = function()
		{
			//接続確認後，ICTモードでない場合
			if(!ictMode)
			{
				//通信の設定
				window.addEventListener('message', getDataFromFrame);
				
				//iframeにバージョンチェックページを読み込む
				var cFrame = document.getElementById("checkFrame");
				
				cFrame.onload = function()
				{
					//バージョンチェックの一定時間ごとの送信
					getVersionTimeout();
				}
				
				cFrame.src = checkURL;
			}
		}
		
		//接続できない場合
		img.onerror = function()
		{
			img.onload = null;
			img.onerror = null;
			delete img;
			
			//バージョンチェックの要素を削除
			setVersionCheck(false);
		}
		
		//接続チェック用の画像を読み込む
		img.src = checkURL.substring(0, checkURL.lastIndexOf(".")) + ".png";
	}
	catch(e)
	{
		//alert("checkVersionHandler:" + e.toString());
	}
}

var getVersionTimeout = function()
{
	try
	{
		//送信データ
		var dataStr = contentID +","+ contentVersion;
		
		document.getElementById("checkFrame").contentWindow.postMessage(dataStr, checkURL);
	}
	catch(e)
	{
		//alert("getVersionTimeout:" + e.toString());
	}
}

function getDataFromFrame(e)
{
	try
	{
		if(e.data == "wait")
		{
			//再送信
			setTimeout(getVersionTimeout(), 1000);
		}
		else if(e.data == "false")
		{
			//バージョンチェックの要素を削除
			setVersionCheck(false);
			window.removeEventListener('message', getDataFromFrame);
		}
		else
		{
			//バージョンチェックのページを表示
			setVersionCheck(e.data);
			window.removeEventListener('message', getDataFromFrame);
		}
	}
	catch(e)
	{
		//alert("getDataFromFrame:" + e.toString());
	}
}


function setVersionCheck(versionURL)
{
	try
	{
		if(versionURL != false)
		{
			//ヘルプウィンドウのタブ
			document.getElementById("versionOpen").addEventListener("click", 
				function(e)
				{
					//リンクを開く
					window.open(versionURL, "_blank");
					
					//モーダルを閉じる
					closeModal("versionCheckBlock");
				});
			
			document.getElementById("versionClose").addEventListener("click", 
				function(e)
				{
					//モーダルを閉じる
					closeModal("versionCheckBlock");
				});

			setModal("versionCheckBlock");
			
			showModal("versionCheckBlock");
		}
		else
		{
			$("versionCheckBlock").remove();
		}
	}
	catch(e)
	{
		//alert("setVersionCheck:" + e.toString());
	}
}

function loadData(str)
{
	try
	{
		var array = JSON.parse(str);
		
		//データの読み込み
		if(array[0] == contentID)
		{
			loadDraw(array[1]);
			loadContent(array[2]);
		
			if(array.length > 3)
			{
				cScale = array[3][0];
				
				if(document.getElementById("graphCanvas") != undefined)
				{
					$("#graphCanvas").width(cW * cScale);
					$("#graphCanvas").height(cH * cScale);
				
					document.getElementById("graphCanvas").style.left = array[3][1] + "px";
					document.getElementById("graphCanvas").style.top = array[3][2] + "px";
					
					changeAxisPositionHandler();
				
					changeFormulaPositionHandler(2);
				}
				
				cs.update();
			}
		}
		//データのIDが違う
		else
		{
			alert("このコンテンツのセーブデータではありません。");
		}
	}
	catch(e)
	{
		alert("読み込みエラー：このコンテンツのセーブデータではありません。");
	}
}


function loadDraw(array)
{
	try
	{
		//前の描画をすべて削除
		paper.clear();
		objArray = array.slice();
		
		for(var i=0; i<objArray.length; i++)
		{
			if(objArray[i] != null)
			{
				switch(objArray[i][0])
				{
					//ペン
					case "pen":
						var penPath = paper.path();
						drawSvgLine(penPath, true, "pen"+i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4]);
						setTouchEvent(true, i);
						break;
					
					//マーカー
					case "mar":
						var marPath = paper.path();
						drawSvgLine(marPath, false, "mar"+i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4]);
						setTouchEvent(false, i);
						break;
					
					//スタンプ（画像）
					case "img":
						addImageToSvgCanvas(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], objArray[i][5]);
						break;
					
					case "pnt":
						createPoint(i, objArray[i][1], objArray[i][2], false);
						break;
					
					case "lin":
						createLine(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], false);
						break;
					
					case "cir":
						createCircle(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], false);
						break;
					
					case "sqr":
						createSquare(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], false);
						break;
					
					case "rct":
						createRectangle(i, objArray[i][1], false);
						break;
					
					case "eqt":
						createEqTriangle(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], false);
						break;
					
					case "tri":
						createTriangle(i, objArray[i][1], false);
						break;
					
					case "txt":
						createText(i, objArray[i][1], objArray[i][2], objArray[i][3], objArray[i][4], objArray[i][5]);
						break;
				}
			}
		}
	}
	catch(e)
	{
		//alert('loadDraw:' + e.toString());
	}
}

//HTMLの分数
function createFrac(n, d, c)
{
	try
	{
		var t = '<table class="frac"><tr><td  class="numer">'+n+'</td></tr><tr><td class="denom" style="border-top:1px '+c+' solid">'+d+'</td></tr></table>';
		
		return t;
	}
	catch(e)
	{
		alert("createFrac:" + e.toString());
	}
}

//easeljsでの分数
function createEaselFrac(c0, c1)
{
	try
	{
		//余白
		var span = 2;
		
		//分数オブジェクト
		var c = new createjs.Container();
		
		var h0 = c0.getBounds().height;
		var h1 = c1.getBounds().height;
		
		var w0 = c0.getBounds().width;
		var w1 = c1.getBounds().width;
		
		var w = Math.max(w0, w1)+span*2;
		
		var s = new createjs.Shape();
		s.graphics.setStrokeStyle(1);
		s.graphics.beginStroke("#000000");
		s.graphics.moveTo(0, 0);
		s.graphics.lineTo(Math.max(w0, w1)+4, 0);
		
		c.addChild(c0);
		c.addChild(c1);
		c.addChild(s);
		
		c0.x = (w-w0)/2;
		c1.x = (w-w1)/2;
		c0.y = 0;
		c1.y = h0+span*2;
		s.y = h0+span;
		
		return c;
	}
	catch(e)
	{
		alert("createEaselFrac:" + e.toString());
	}
}
