// JavaScript Document

var figureNum;

//点
function createPoint(num, x0, y0, f)
{
	try
	{
		
		var s = paper.set();
		s.id = "set" + num;
		
		var alpha;
		if(f)
		{
			alpha = 0.5;
		}
		else
		{
			alpha = 0;
		}
		
		var c0 = paper.circle(x0, y0, 3).attr({"stroke-width":0,"fill":"#000000","fill-opacity": 1});
		c0.id = "pnt" + num;
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(x0, y0, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": alpha});
		c1.id = "ctr" + num;
		c1.node.setAttribute('class', 'figureSvg');
		
		s.push(
			c0,
			c1
		);
		
		function pointDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:" + e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				c0.attr({cx:pX, cy:pY});
				c1.attr({cx:pX, cy:pY});
				
				objArray[num][1] = pX;
				objArray[num][2] = pY;
				
				
			}
			catch(e)
			{
				//alert("pointDragMove:" + e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:" + e.toString());
			}
		}
		
		if(ictMode)
		{
			c1.touchstart(pointDragStart);
			c1.mousedown(pointDragStart);
		}
		else if(mFlag)
		{
			c1.touchstart(pointDragStart);
		}
		else
		{
			c1.mousedown(pointDragStart);
		}
	}
	catch(e)
	{
		//alert("createPoint:"+e.toString());
	}
}

//線分
function createLine(num, x0, y0, x1, y1, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		var line0 = paper.path("M"+x0+","+y0+"L"+x1+","+y1).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		line0.id = "lin"+num+"_0";
		line0.node.setAttribute('class', 'figureSvg');
		
		var line1 = paper.path("M"+x0+","+y0+"L"+x1+","+y1).attr({"stroke-width":20,"stroke":"#FF0000", "stroke-opacity":0});
		line1.id = "lin"+num+"_1";
		line1.node.setAttribute('class', 'figureSvg');
		
		var c0 = paper.circle(x0, y0, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c0.id = "ctr" + num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(x1, y1, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c1.id = "ctr" + num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		s.push(
			line0,
			line1,
			c0,
			c1
		);
		
		if(!f)
		{
			c0.hide();
			c1.hide();
		}
		
		var ctrl;
		
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;	
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:" + e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var str = ctrl.substring(ctrl.length-1, ctrl.length);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				if(str == "0")
				{
					objArray[num][1] = pX;
					objArray[num][2] = pY;
					
					c0.attr({cx:pX, cy:pY});
				}
				else
				{
					objArray[num][3] = pX;
					objArray[num][4] = pY;
					
					c1.attr({cx:pX, cy:pY});
				}
				
				var lineStr = "M"+c0.attr("cx")+","+c0.attr("cy")+"L"+c1.attr("cx")+","+c1.attr("cy");
				line0.attr({path:lineStr});
				line1.attr({path:lineStr});
			}
			catch(e)
			{
				//alert("pointDragMove:" + e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:" + e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		
		function lineDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", lineDragMove);
					document.addEventListener("touchend", lineDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", lineDragMove);
					document.addEventListener("mouseup", lineDragStop);
				}
				
				sX0 = objArray[num][1] - pX;
				sY0 = objArray[num][2] - pY;
				
				sX1 = objArray[num][3] - pX;
				sY1 = objArray[num][4] - pY;
			}
			catch(e)
			{
				//alert("lineDragStart:" + e.toString());
			}
		}
		
		function lineDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				c0.attr({cx:pX+sX0, cy:pY+sY0});
				c1.attr({cx:pX+sX1, cy:pY+sY1});
				
				var lineStr = "M"+c0.attr("cx")+","+c0.attr("cy")+"L"+c1.attr("cx")+","+c1.attr("cy");
				line0.attr({path:lineStr});
				line1.attr({path:lineStr});
				
				objArray[num][1] = c0.attr("cx");
				objArray[num][2] = c0.attr("cy");
				
				objArray[num][3] = c1.attr("cx");
				objArray[num][4] = c1.attr("cy");
			}
			catch(e)
			{
				//alert("pointDragMove:" + e.toString());
			}
		}
			
		function lineDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", lineDragMove);
					document.removeEventListener("touchend", lineDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", lineDragMove);
					document.removeEventListener("mouseup", lineDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:" + e.toString());
			}
		}
		
		if(ictMode)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			
			line1.touchstart(lineDragStart);
			
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			
			line1.mousedown(lineDragStart);
		}
		else if(mFlag)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			
			line1.touchstart(lineDragStart);
		}
		else
		{
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			
			line1.mousedown(lineDragStart);
		}
	}
	catch(e)
	{
		//alert("createLine:"+e.toString());
	}
}


//円
function createCircle(num, x0, y0, x1, y1, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		var leng = Math.sqrt((x0-x1)*(x0-x1) + (y0-y1)*(y0-y1));
		
		var c0 = paper.circle(x0, y0, leng).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		c0.id = "cir" + num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(x0, y0, leng).attr({"stroke-width":20,"stroke":"#FF0000", "stroke-opacity":0});
		c1.id = "cir" + num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		var c2 = paper.circle(x1, y1, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity":0.5});
		c2.id = "ctr" + num;
		c2.node.setAttribute('class', 'figureSvg');
		
		s.push(
			c0,
			c1,
			c2
		);
		
		if(!f)
		{
			c2.hide();
		}
		
		//円の変形
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:" + e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				objArray[num][3] = pX;
				objArray[num][4] = pY;
				
				var leng = Math.sqrt((pX - objArray[num][1])*(pX - objArray[num][1]) + (pY - objArray[num][2])*(pY - objArray[num][2]));
				
				c0.attr({r:leng});
				c1.attr({r:leng});
				c2.attr({cx:pX, cy:pY});
			}
			catch(e)
			{
				//alert("pointDragMove:" + e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:" + e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		
		//円の移動
		function circleDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				sX0 = objArray[num][1] - pX;
				sY0 = objArray[num][2] - pY;
				
				sX1 = objArray[num][3] - pX;
				sY1 = objArray[num][4] - pY;
				
				
				if(ictMode)
				{
					document.addEventListener("touchmove", circleDragMove);
					document.addEventListener("touchend", circleDragStop);
					
					document.addEventListener("mousemove", circleDragMove);
					document.addEventListener("mouseup", circleDragStop);
				}
				else if(mFlag)
				{
					document.addEventListener("touchmove", circleDragMove);
					document.addEventListener("touchend", circleDragStop);
				}
				else
				{
					document.addEventListener("mousemove", circleDragMove);
					document.addEventListener("mouseup", circleDragStop);
				}
			}
			catch(e)
			{
				//alert("circleDragStart:" + e.toString());
			}
		}
		
		function circleDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				objArray[num][1] = pX+sX0;
				objArray[num][2] = pY+sY0;
				
				objArray[num][3] = pX+sX1;
				objArray[num][4] = pY+sY1;
				
				c0.attr({cx:pX+sX0, cy:pY+sY0});
				c1.attr({cx:pX+sX0, cy:pY+sY0});
				
				c2.attr({cx:pX+sX1, cy:pY+sY1});
			}
			catch(e)
			{
				//alert("circleDragMove:" + e.toString());
			}
		}
		
		function circleDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", circleDragMove);
					document.removeEventListener("touchend", circleDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", circleDragMove);
					document.removeEventListener("mouseup", circleDragStop);
				}
			}
			catch(e)
			{
				//alert("circleDragStop:" + e.toString());
			}
		}
		
		if(ictMode)
		{
			c1.touchstart(circleDragStart);
			c2.touchstart(pointDragStart);
			
			c1.mousedown(circleDragStart);
			c2.mousedown(pointDragStart);
		}
		else if(mFlag)
		{
			c1.touchstart(circleDragStart);
			c2.touchstart(pointDragStart);
		}
		else
		{
			c1.mousedown(circleDragStart);
			c2.mousedown(pointDragStart);
		}
	}
	catch(e)
	{
		//alert("createCircle:"+e.toString());
	}
}

//正方形
function createSquare(num, x0, y0, x1, y1, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		var leng = Math.sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0));
		var rot = Math.atan2(y1-y0, x1-x0);
		
		var x2 = x0+leng*Math.cos(rot+Math.PI/2);
		var y2 = y0+leng*Math.sin(rot+Math.PI/2);
		var x3 = x0+leng*Math.cos(rot+Math.PI); 
		var y3 = y0+leng*Math.sin(rot+Math.PI);
		var x4 = x0+leng*Math.cos(rot-Math.PI/2);
		var y4 = y0+leng*Math.sin(rot-Math.PI/2);
		
		var str = "M"+x1+","+y1+"L"+x2+","+y2+"L"+x3+","+y3+"L"+x4+","+y4+"L"+x1+","+y1;
		
		var rect0 = paper.path(str).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		rect0.id = "rct"+num+"_0";
		rect0.node.setAttribute('class', 'figureSvg');
		
		var rect1 = paper.path(str).attr({"stroke-width":20,"stroke":"#FF0000", "stroke-opacity":0});
		rect1.id = "rct"+num+"_1";
		rect1.node.setAttribute('class', 'figureSvg');
		
		
		var c0 = paper.circle(x1, y1, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c0.id = "ctr"+num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(x2, y2, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c1.id = "ctr"+num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		var c2 = paper.circle(x3, y3, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c2.id = "ctr"+num+"_2";
		c2.node.setAttribute('class', 'figureSvg');
		
		var c3 = paper.circle(x4, y4, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c3.id = "ctr"+num+"_3";
		c3.node.setAttribute('class', 'figureSvg');
		
		s.push(
			rect0,
			rect1,
			c0,
			c1,
			c2,
			c3
		);
		
		if(!f)
		{
			c0.hide();
			c1.hide();
			c2.hide();
			c3.hide();
		}
		
		var ctrl;
		
		var leng;
		var rot;
		
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:"+e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
			
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				leng = Math.sqrt((objArray[num][1]-pX)*(objArray[num][1]-pX)+(objArray[num][2]-pY)*(objArray[num][2]-pY));
				rot = Math.atan2(pY-objArray[num][2], pX-objArray[num][1]);
				
				var str = ctrl.substring(ctrl.length-1, ctrl.length);
				
				if(str == "0")
				{
					c0.attr({cx:pX, cy:pY});
					
					c1.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI/2)});
					c2.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI)});
					c3.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI/2)});
				}
				else if(str == "1")
				{
					c1.attr({cx:pX, cy:pY});
					
					c0.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI/2)});
					c2.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI/2)});
					c3.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI)});
				}
				else if(str == "2")
				{
					c2.attr({cx:pX, cy:pY});
					
					c0.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI)});
					c1.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI/2)});
					c3.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI/2)});
				}
				else
				{
					c3.attr({cx:pX, cy:pY});
					
					c0.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI/2)});
					c1.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI)});
					c2.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI/2)});
				}
				
				objArray[num][3] = c0.attr("cx");
				objArray[num][4] = c0.attr("cy");
				
				var str = getPathString([[c0.attr("cx"),c0.attr("cy")],[c1.attr("cx"),c1.attr("cy")],[c2.attr("cx"),c2.attr("cy")],[c3.attr("cx"),c3.attr("cy")],[c0.attr("cx"),c0.attr("cy")]]);
				
				rect0.attr({path:str});
				rect1.attr({path:str});
			}
			catch(e)
			{
				//alert("pointDragMove:"+e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:"+e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		
		function rectDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", rectDragMove);
					document.addEventListener("touchend", rectDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", rectDragMove);
					document.addEventListener("mouseup", rectDragStop);
				}
				
				leng = Math.sqrt((objArray[num][1]-objArray[num][3])*(objArray[num][1]-objArray[num][3])+(objArray[num][2]-objArray[num][4])*(objArray[num][2]-objArray[num][4]));
				rot = Math.atan2(objArray[num][4]-objArray[num][2], objArray[num][3]-objArray[num][1]);
				
				sX0 = objArray[num][1] - pX;
				sY0 = objArray[num][2] - pY;
				
				sX1 = c0.attr("cx") - pX;
				sY1 = c0.attr("cy") - pY;
				sX2 = c1.attr("cx") - pX;
				sY2 = c1.attr("cy") - pY;
			}
			catch(e)
			{
				//alert("rectDragStart:"+e.toString());
			}
		}
		
		function rectDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				c0.attr({cx:pX+sX1, cy:pY+sY1});
				
				//値の修正
				objArray[num][1] = pX+sX0;
				objArray[num][2] = pY+sY0;
				
				objArray[num][3] = c0.attr("cx");
				objArray[num][4] = c0.attr("cy");
				
				c1.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI/2)});
				c2.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI)});
				c3.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI/2), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI/2)});
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c3.attr("cx"),c3.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				rect0.attr({path:str});
				rect1.attr({path:str});
				
			}
			catch(e)
			{
				//alert("rectDragMove:"+e.toString());
			}
		}
		
		function rectDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", rectDragMove);
					document.removeEventListener("touchend", rectDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", rectDragMove);
					document.removeEventListener("mouseup", rectDragStop);
				}
			}
			catch(e)
			{
				//alert("rectDragStop:"+e.toString());
			}
		}
		
		if(ictMode)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			c3.touchstart(pointDragStart);
			rect1.touchstart(rectDragStart);
			
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			c3.mousedown(pointDragStart);
			rect1.mousedown(rectDragStart);
		}
		else if(mFlag)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			c3.touchstart(pointDragStart);
			rect1.touchstart(rectDragStart);
		}
		else
		{
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			c3.mousedown(pointDragStart);
			rect1.mousedown(rectDragStart);
		}
	}
	catch(e)
	{
		//alert("createSquare:"+e.toString());
	}
}

//四角形
function createRectangle(num, array, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		var strArray = array.slice();
		strArray.push(strArray[0]);
		
		var str = getPathString(strArray);
		
		var rect0 = paper.path(str).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		rect0.id = "rct"+num+"_0";
		rect0.node.setAttribute('class', 'figureSvg');
		
		var rect1 = paper.path(str).attr({"stroke-width":20,"stroke":"#FF0000", "stroke-opacity":0});
		rect1.id = "rct"+num+"_1";
		rect1.node.setAttribute('class', 'figureSvg');
		
		var c0 = paper.circle(array[0][0], array[0][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c0.id = "ctr"+num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(array[1][0], array[1][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c1.id = "ctr"+num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		var c2 = paper.circle(array[2][0], array[2][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c2.id = "ctr"+num+"_2";
		c2.node.setAttribute('class', 'figureSvg');
		
		var c3 = paper.circle(array[3][0], array[3][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c3.id = "ctr"+num+"_3";
		c3.node.setAttribute('class', 'figureSvg');
		
		s.push(
			rect0,
			rect1,
			c0,
			c1,
			c2,
			c3
		);
		
		if(!f)
		{
			c0.hide();
			c1.hide();
			c2.hide();
			c3.hide();
		}
		
		var ctrl;
		
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:"+e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				var str = ctrl.substring(ctrl.length-1, ctrl.length);
				
				if(str == "0")
				{
					c0.attr({cx:pX, cy:pY});
					objArray[num][1][0][0] = pX;
					objArray[num][1][0][1] = pY;
				}
				else if(str == "1")
				{
					c1.attr({cx:pX, cy:pY});
					objArray[num][1][1][0] = pX;
					objArray[num][1][1][1] = pY;
				}
				else if(str == "2")
				{
					c2.attr({cx:pX, cy:pY});
					objArray[num][1][2][0] = pX;
					objArray[num][1][2][1] = pY;
				}
				else
				{
					c3.attr({cx:pX, cy:pY});
					objArray[num][1][3][0] = pX;
					objArray[num][1][3][1] = pY;
				}
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c3.attr("cx"),c3.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				rect0.attr({path:str});
				rect1.attr({path:str});
			}
			catch(e)
			{
				//alert("pointDragMove:"+e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:"+e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		var sX2;
		var sY2;
		var sX3;
		var sY3;
		
		function rectDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", rectDragMove);
					document.addEventListener("touchend", rectDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", rectDragMove);
					document.addEventListener("mouseup", rectDragStop);
				}
				
				sX0 = c0.attr("cx") - pX;
				sY0 = c0.attr("cy") - pY;
				sX1 = c1.attr("cx") - pX;
				sY1 = c1.attr("cy") - pY;
				sX2 = c2.attr("cx") - pX;
				sY2 = c2.attr("cy") - pY;
				sX3 = c3.attr("cx") - pX;
				sY3 = c3.attr("cy") - pY;
			}
			catch(e)
			{
				//alert("rectDragStart:"+e.toString());
			}
		}
		
		function rectDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				c0.attr({cx:pX+sX0, cy:pY+sY0});
				c1.attr({cx:pX+sX1, cy:pY+sY1});
				c2.attr({cx:pX+sX2, cy:pY+sY2});
				c3.attr({cx:pX+sX3, cy:pY+sY3});
				
				objArray[num][1][0][0] = c0.attr("cx");
				objArray[num][1][0][1] = c0.attr("cy");
				objArray[num][1][1][0] = c1.attr("cx");
				objArray[num][1][1][1] = c1.attr("cy");
				objArray[num][1][2][0] = c2.attr("cx");
				objArray[num][1][2][1] = c2.attr("cy");
				objArray[num][1][3][0] = c2.attr("cx");
				objArray[num][1][3][1] = c2.attr("cy");
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c3.attr("cx"),c3.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				rect0.attr({path:str});
				rect1.attr({path:str});
			}
			catch(e)
			{
				//alert("rectDragMove:"+e.toString());
			}
		}
		
		function rectDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", rectDragMove);
					document.removeEventListener("touchend", rectDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", rectDragMove);
					document.removeEventListener("mouseup", rectDragStop);
				}
			}
			catch(e)
			{
				//alert("rectDragStop:"+e.toString());
			}
		}
		
		if(ictMode)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			c3.touchstart(pointDragStart);
			rect1.touchstart(rectDragStart);
			
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			c3.mousedown(pointDragStart);
			rect1.mousedown(rectDragStart);
		}
		else if(mFlag)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			c3.touchstart(pointDragStart);
			rect1.touchstart(rectDragStart);
		}
		else
		{
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			c3.mousedown(pointDragStart);
			rect1.mousedown(rectDragStart);
		}
	}
	catch(e)
	{
		//alert("createRectangle:"+e.toString());
	}
}


//正三角形
function createEqTriangle(num, x0, y0, x1, y1, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		//中心からの距離
		var leng = Math.sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1));
		
		//角度
		var rot = Math.atan2(y1-y0, x1-x0);
		
		var x2 = x0 + leng * Math.cos(rot+Math.PI*2/3);
		var y2 = y0 + leng * Math.sin(rot+Math.PI*2/3);
		
		var x3 = x0 + leng * Math.cos(rot-Math.PI*2/3);
		var y3 = y0 + leng * Math.sin(rot-Math.PI*2/3);
		
		var str = getPathString([[x1,y1],[x2,y2],[x3,y3],[x1,y1]]);
		
		
		var line0 = paper.path(str).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		line0.id = "lin"+num+"_0";
		var line1 = paper.path(str).attr({"stroke-width":10,"stroke":"#FF0000", "stroke-opacity":0});
		line1.id = "lin"+num+"_1";
		
		var c0 = paper.circle(x1, y1, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c0.id = "ctr" + num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(x2, y2, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c1.id = "ctr" + num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		var c2 = paper.circle(x3, y3, 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c2.id = "ctr" + num+"_2";
		c2.node.setAttribute('class', 'figureSvg');
		
		s.push(
			line0,
			line1,
			c0,
			c1,
			c2
		);
		
		if(!f)
		{
			c0.hide();
			c1.hide();
			c2.hide();
		}
		
		var ctrl;
		
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:"+e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				leng = Math.sqrt((objArray[num][1]-pX)*(objArray[num][1]-pX)+(objArray[num][2]-pY)*(objArray[num][2]-pY));
				rot = Math.atan2(pY-objArray[num][2], pX-objArray[num][1]);
				var str = ctrl.substring(ctrl.length-1, ctrl.length);
				
				if(str == "0")
				{
					c0.attr({cx:pX, cy:pY});
					
					c1.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI * 2/3), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI * 2/3)});
					c2.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI * 2/3), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI * 2/3)});
					
				}
				else if(str == "1")
				{
					c1.attr({cx:pX, cy:pY});
					
					c2.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI * 2/3), cy:objArray[num][2]+leng*Math.sin(rot+Math.PI * 2/3)});
					c0.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI * 2/3), cy:objArray[num][2]+leng*Math.sin(rot-Math.PI * 2/3)});
				}
				else
				{
					c2.attr({cx:pX, cy:pY});
					
					c0.attr({cx:objArray[num][1]+leng*Math.cos(rot+Math.PI * 2/3),cy:objArray[num][2]+leng*Math.sin(rot+Math.PI * 2/3)});
					c1.attr({cx:objArray[num][1]+leng*Math.cos(rot-Math.PI * 2/3),cy:objArray[num][2]+leng*Math.sin(rot-Math.PI * 2/3)});
				}
				
				objArray[num][3] = c0.attr("cx");
				objArray[num][4] = c0.attr("cy");
				
				var str = getPathString([[c0.attr("cx"),c0.attr("cy")],[c1.attr("cx"),c1.attr("cy")],[c2.attr("cx"),c2.attr("cy")],[c0.attr("cx"),c0.attr("cy")]]);
				
				line0.attr({path:str});
				line1.attr({path:str});
				
			}
			catch(e)
			{
				//alert("pointDragMove:"+e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:"+e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		var sX2;
		var sY2;
		var sX3;
		var sY3;
		
		function triangleDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", triangleDragMove);
					document.addEventListener("touchend", triangleDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", triangleDragMove);
					document.addEventListener("mouseup", triangleDragStop);
				}
				
				sX0 = objArray[num][1]-pX;
				sY0 = objArray[num][2]-pY;
				
				sX1 = c0.attr("cx")-pX;
				sY1 = c0.attr("cy")-pY;
				
				sX2 = c1.attr("cx")-pX;
				sY2 = c1.attr("cy")-pY;
				
				sX3 = c2.attr("cx")-pX;
				sY3 = c2.attr("cy")-pY;
			}
			catch(e)
			{
				//alert("triangleDragStart:"+e.toString());
			}
		}
		
		function triangleDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				objArray[num][1] = pX + sX0;
				objArray[num][2] = pY + sY0;
				
				c0.attr({cx:pX+sX1, cy:pY+sY1});
				
				objArray[num][3] = c0.attr("cx");
				objArray[num][4] = c0.attr("cy");
				
				
				c1.attr({cx:pX+sX2, cy:pY+sY2});
				c2.attr({cx:pX+sX3, cy:pY+sY3});
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				line0.attr({path:str});
				line1.attr({path:str});
			}
			catch(e)
			{
				//alert("triangleDragMove:"+e.toString());
			}
		}
		
		function triangleDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", triangleDragMove);
					document.removeEventListener("touchend", triangleDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", triangleDragMove);
					document.removeEventListener("mouseup", triangleDragStop);
				}
			}
			catch(e)
			{
				//alert("triangleDragStop:"+e.toString());
			}
		}
		
		if(ictMode)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			line1.touchstart(triangleDragStart);
			
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			line1.mousedown(triangleDragStart);
		}
		else if(mFlag)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			line1.touchstart(triangleDragStart);
		}
		else
		{
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			line1.mousedown(triangleDragStart);
		}
	}
	catch(e)
	{
		//alert("createEqTriangle:"+e.toString());
	}
}

//三角形
function createTriangle(num, array, f)
{
	try
	{
		var s = paper.set();
		s.id = "set" + num;
		
		var strArray = array.slice();
		
		strArray.push(strArray[0]);
		
		var str = getPathString(strArray);
		
		
		var line0 = paper.path(str).attr({"stroke-width":1,"stroke":"#000000", "stroke-opacity":1});
		line0.id = "lin"+num+"_0";
		line0.node.setAttribute('class', 'figureSvg');
		
		var line1 = paper.path(str).attr({"stroke-width":20,"stroke":"#FF0000", "stroke-opacity":0});
		line1.id = "lin"+num+"_1";
		line1.node.setAttribute('class', 'figureSvg');
		
		var c0 = paper.circle(array[0][0], array[0][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c0.id = "ctr" + num+"_0";
		c0.node.setAttribute('class', 'figureSvg');
		
		var c1 = paper.circle(array[1][0], array[1][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c1.id = "ctr" + num+"_1";
		c1.node.setAttribute('class', 'figureSvg');
		
		var c2 = paper.circle(array[2][0], array[2][1], 10).attr({"stroke-width":0,"fill":"#FF0000","fill-opacity": 0.5});
		c2.id = "ctr" + num+"_2";
		c2.node.setAttribute('class', 'figureSvg');
		
		s.push(
			line0,
			line1,
			c0,
			c1,
			c2
		);
		
		if(!f)
		{
			c0.hide();
			c1.hide();
			c2.hide();
		}
		
		var ctrl;
		
		
		function pointDragStart(e)
		{
			try
			{
				if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				ctrl = this.id;
				
				if(e.type == "touchstart")
				{
					document.addEventListener("touchmove", pointDragMove);
					document.addEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mousedown")
				{
					document.addEventListener("mousemove", pointDragMove);
					document.addEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStart:"+e.toString());
			}
		}
		
		function pointDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
					
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				var str = ctrl.substring(ctrl.length-1, ctrl.length);
				
				if(str == "0")
				{
					c0.attr({cx:pX, cy:pY});
					objArray[num][1][0][0] = pX;
					objArray[num][1][0][1] = pY;
				}
				else if(str == "1")
				{
					c1.attr({cx:pX, cy:pY});
					objArray[num][1][1][0] = pX;
					objArray[num][1][1][1] = pY;
				}
				else
				{
					c2.attr({cx:pX, cy:pY});
					objArray[num][1][2][0] = pX;
					objArray[num][1][2][1] = pY;
				}
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				line0.attr({path:str});
				line1.attr({path:str});
			}
			catch(e)
			{
				//alert("pointDragMove:"+e.toString());
			}
		}
		
		function pointDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", pointDragMove);
					document.removeEventListener("touchend", pointDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", pointDragMove);
					document.removeEventListener("mouseup", pointDragStop);
				}
			}
			catch(e)
			{
				//alert("pointDragStop:"+e.toString());
			}
		}
		
		var sX0;
		var sY0;
		var sX1;
		var sY1;
		var sX2;
		var sY2;
		
		function triangleDragStart(e)
		{
			try
			{
				if(mode == "eraser")
				{
					objArray[num] = null;
					s.remove();	
					
					return;
				}
				else if(mode != "figure")
				{
					return;
				}
				
				if(e.type == undefined)
				{
					return;
				}
				
				changeSelectFigure(num);
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchstart")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
					
					document.addEventListener("touchmove", triangleDragMove);
					document.addEventListener("touchend", triangleDragStop);
				}
				else if(e.type == "mousedown")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
					
					document.addEventListener("mousemove", triangleDragMove);
					document.addEventListener("mouseup", triangleDragStop);
				}
				
				sX0 = c0.attr("cx") - pX;
				sY0 = c0.attr("cy") - pY;
				sX1 = c1.attr("cx") - pX;
				sY1 = c1.attr("cy") - pY;
				sX2 = c2.attr("cx") - pX;
				sY2 = c2.attr("cy") - pY;
			}
			catch(e)
			{
				//alert("triangleDragStart:"+e.toString());
			}
		}
		
		function triangleDragMove(e)
		{
			try
			{
				e.preventDefault();
				
				var rect = document.getElementById('svgCanvas').getBoundingClientRect();
				var pX;
				var pY;
				
				if(e.type == "touchmove")
				{
					pX = e.targetTouches[0].pageX - rect.left;
					pY = e.targetTouches[0].pageY;
				}
				else if(e.type == "mousemove")
				{
					pX = e.pageX - rect.left;
					pY = e.pageY;
				}
				
				c0.attr({cx:pX+sX0, cy:pY+sY0});
				c1.attr({cx:pX+sX1, cy:pY+sY1});
				c2.attr({cx:pX+sX2, cy:pY+sY2});
				
				objArray[num][1][0][0] = c0.attr("cx");
				objArray[num][1][0][1] = c0.attr("cy");
				objArray[num][1][1][0] = c1.attr("cx");
				objArray[num][1][1][1] = c1.attr("cy");
				objArray[num][1][2][0] = c2.attr("cx");
				objArray[num][1][2][1] = c2.attr("cy");
				
				var pArray = [
					[c0.attr("cx"),c0.attr("cy")],
					[c1.attr("cx"),c1.attr("cy")],
					[c2.attr("cx"),c2.attr("cy")],
					[c0.attr("cx"),c0.attr("cy")]];
				
				var str = getPathString(pArray);
				
				line0.attr({path:str});
				line1.attr({path:str});
			}
			catch(e)
			{
				//alert("triangleDragMove:"+e.toString());
			}
		}
		
		function triangleDragStop(e)
		{
			try
			{
				if(e.type == "touchend")
				{
					document.removeEventListener("touchmove", triangleDragMove);
					document.removeEventListener("touchend", triangleDragStop);
				}
				else if(e.type == "mouseup")
				{
					document.removeEventListener("mousemove", triangleDragMove);
					document.removeEventListener("mouseup", triangleDragStop);
				}
			}
			catch(e)
			{
				//alert("triangleDragStop:"+e.toString());
			}
		}
		
		if(ictMode)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			line1.touchstart(triangleDragStart);
			
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			line1.mousedown(triangleDragStart);
		}
		else if(mFlag)
		{
			c0.touchstart(pointDragStart);
			c1.touchstart(pointDragStart);
			c2.touchstart(pointDragStart);
			line1.touchstart(triangleDragStart);
		}
		else
		{
			c0.mousedown(pointDragStart);
			c1.mousedown(pointDragStart);
			c2.mousedown(pointDragStart);
			line1.mousedown(triangleDragStart);
		}
	}
	catch(e)
	{
		//alert("createTriangle:"+e.toString());
	}
}

function getPathString(array)
{
	try
	{
		var str;
		
		for(var i=0; i<array.length; i++)
		{
			if(i==0)
			{
				str = "M"+array[i][0]+","+array[i][1];
			}
			else
			{
				str = str+"L"+array[i][0]+","+array[i][1];
			}
		}
		
		return str;
	}
	catch(e)
	{
		//alert("getPathString:" + e.toString());
	}
}

function changeSelectFigure(num)
{
	try
	{
		for(var i=0; i<objArray.length; i++)
		{
			var f;
			if(i == num)
			{
				f = true;
			}
			else
			{
				f = false;
			}
			
			if(objArray[i] != null)
			{
				//点
				if(objArray[i][0] == "pnt")
				{
					if(f)
					{
						paper.getById("ctr"+i).attr({"fill-opacity": 0.5});
					}
					else
					{
						paper.getById("ctr"+i).attr({"fill-opacity": 0});
					}
				}
				//線
				else if(objArray[i][0] == "lin")
				{
					if(f)
					{
						paper.getById("ctr"+i+"_0").show();
						paper.getById("ctr"+i+"_1").show();
					}
					else
					{
						paper.getById("ctr"+i+"_0").hide();
						paper.getById("ctr"+i+"_1").hide();
					}
				}
				//円
				else if(objArray[i][0] == "cir")
				{
					if(f)
					{
						paper.getById("ctr"+i).show();
					}
					else
					{
						paper.getById("ctr"+i).hide();
					}
				}
				//正方形もしくは四角形
				else if(objArray[i][0] == "sqr" || objArray[i][0] == "rct")
				{
					if(f)
					{
						paper.getById("ctr"+i+"_0").show();
						paper.getById("ctr"+i+"_1").show();
						paper.getById("ctr"+i+"_2").show();
						paper.getById("ctr"+i+"_3").show();
					}
					else
					{
						paper.getById("ctr"+i+"_0").hide();
						paper.getById("ctr"+i+"_1").hide();
						paper.getById("ctr"+i+"_2").hide();
						paper.getById("ctr"+i+"_3").hide();
					}
				}
				//正三角形もしくは三角形
				else if(objArray[i][0] == "eqt" || objArray[i][0] == "tri")
				{
					if(f)
					{
						paper.getById("ctr"+i+"_0").show();
						paper.getById("ctr"+i+"_1").show();
						paper.getById("ctr"+i+"_2").show();
					}
					else
					{
						paper.getById("ctr"+i+"_0").hide();
						paper.getById("ctr"+i+"_1").hide();
						paper.getById("ctr"+i+"_2").hide();
					}
				}
			}
		}
		
		figureNum = num;
	}
	catch(e)
	{
		//alert("changeSelectFigure:" + e.toString());
	}
}