// JavaScript Document

var bW;
var bH;

var cW;
var cH;

//3D設定要素
var scene;
var camera;
var renderer;
var controls;
var projector;

var textArray;

var tm;


//刻み幅
var stepSize;

var span;

//軌跡を制御する場合
var recCont;
var recData;

var dFlag;

var browse;

var spanArray;

var rotFlag;

//線のマテリアル
var lm0;
var lm1;

//面のマテリアル
var pmXY;
var pmYZ;
var pmZX;

//テキストのマテリアル
var tm;

var planeXY;
var planeYZ;
var planeZX;

var obj;

function loadContentHandler()
{
	try
	{
		mFlag = false;
		rotFlag = true;
		var ua = navigator.userAgent;
		var eventStr = "mousedown";
		
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			mFlag = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			mFlag = true;
		}
		
		/**注意**
		
		コンテンツの3軸表示の座標と教科書の図の座標の
		軸の方向が違っています。
		教科書の+x軸　→　+z軸
		教科書の+y軸　→　+x軸
		教科書の+z軸　→　+y軸
		****/
		
		//軸の数値1あたりのサイズ
		span = 5;
		
		stepSize = 1;
		
		var menuSize = 130;
		
		bW = pageWidth-52-menuSize;
		bH = pageHeight;
		
		cW = bW;
		cH = bH;
		
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		
		document.getElementById("graphBlock").style.position = "absolute";
		document.getElementById("graphBlock").style.left = menuSize + "px";
		
		$("#menuClose").css("display", "none");
		
		$("#configBlock").css("display", "none");
		
		animeFlag = false;
		dFlag = true;
		
		$("#check0").prop("checked", false);
		$("#check1").prop("checked", false);
		$("#check2").prop("checked", false);
		
		document.getElementById("check0").addEventListener("change", changePlaneDisplay);
		document.getElementById("check1").addEventListener("change", changePlaneDisplay);
		document.getElementById("check2").addEventListener("change", changePlaneDisplay);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		
		textArray = [];
		
		init3d();
		
		/*
		if(ictMode)
		{
			$("#graphBlock").on('mousedown touchstart', selectObjectHandler);
		}
		else if(mFlag)
		{
			document.getElementById("graphBlock").addEventListener('touchstart', selectObjectHandler);
		}
		else
		{
			document.getElementById("graphBlock").addEventListener('mousedown', selectObjectHandler);
		}
		*/
		
		changeGraphDisplay();
		
		setMenuMode(0, menuSize);
		
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function init3d()
{
	try
	{
		rotFlag = true;
		
		//3Dの設定
		scene = new THREE.Scene();
		
		if(navigator.userAgent.indexOf("Chrome") != -1)
		{
			renderer = new THREE.WebGLRenderer({antialias: false});
		}
		else
		{
			renderer = new THREE.WebGLRenderer({antialias: true});
		}
		
		var dis = 16;
		
		renderer.setSize(cW, cH);
		renderer.setClearColor( new THREE.Color(0xFFFFFF) );
		
		camera = new THREE.OrthographicCamera (-cW/dis, cW/dis, cH/dis, -cH/dis, -500, 1000);
		
		controls = new THREE.OrbitControls(camera, renderer.domElement);
		projector = new THREE.Projector();
		
		camera.position.x = 50;
		camera.position.y = 50;
		camera.position.z = 100;
		
		document.getElementById("graphBlock").appendChild(renderer.domElement);
		
		obj = new THREE.Object3D();
		obj.renderOrder = 10;
		scene.add(obj);
		
		//線のマテリアル
		lm0 =  new THREE.MeshBasicMaterial({color:"#000000", opacity:1, transparent:false});
		lm1 =  new THREE.MeshBasicMaterial({color:"#FF0000", opacity:1, transparent:false});
		
		//テキストのマテリアル
		tm = new THREE.MeshBasicMaterial({color:0x000000, opacity:1, transparent:false})
		
		//平面のマテリアル
		pmXY = new THREE.MeshBasicMaterial({color:0xB8E2F9, opacity:0.5, transparent:true});
		pmXY.side = THREE.DoubleSide;
		pmYZ = new THREE.MeshBasicMaterial({color:0xFDE9BC, opacity:0.5, transparent:true});
		pmYZ.side = THREE.DoubleSide;
		pmZX = new THREE.MeshBasicMaterial({color:0xF7C6CC, opacity:0.5, transparent:true});
		pmZX.side = THREE.DoubleSide;
		
		//軸
		var axis= axisObject(span * 8, span * 8, span * 8, 0.15, 0.5 * 1.5, span/2 * 1.5, lm0, tm);
		obj.add(axis);
		
		textArray.push(axis.getChildByName("textX"));
		textArray.push(axis.getChildByName("textY"));
		textArray.push(axis.getChildByName("textZ"));
		textArray.push(axis.getChildByName("textO"));
		
		planeXY = createSelectPlane(0);
		planeYZ = createSelectPlane(1);
		planeZX = createSelectPlane(2);
		
		obj.add(planeXY);
		obj.add(planeYZ);
		obj.add(planeZX);
		
		obj.position.y = -10;
		
		changeSelectPlane(-1, false);
		
		render();
	}
	catch(e)
	{
		alert("init:" + e.toString());
	}
}

function createSelectPlane(n)
{
	try
	{
		var p = new THREE.Object3D();
		
		//サイズ
		var s = 16;
		
		//平面
		var pMesh;
		
		var pg = new THREE.PlaneGeometry(span * s, span * s, 1, 1, false);
		
		switch(n)
		{
			case 0:
				pMesh = new THREE.Mesh(pg, pmXY);
				pMesh.rotation.x = Math.PI/2;
				pMesh.position.x = 0;
				pMesh.position.z = 0;
				pMesh.name = "p0";
				
				p.rotation.x = Math.PI/2;
				p.position.x = 0;
				p.position.z = 0;
			 	break;
			
			case 1:
				pMesh = new THREE.Mesh(pg, pmYZ);
				pMesh.position.x = 0;
				pMesh.position.y = 0;
				pMesh.name = "p1";
				
				p.position.x = 0;
				p.position.y = 0;
				break;
			
			case 2:
				pMesh = new THREE.Mesh(pg, pmZX);
				pMesh.rotation.y = Math.PI/2;
				pMesh.position.y = 0;
				pMesh.position.z = 0;
				pMesh.name = "p2";
				
				p.rotation.y = Math.PI/2;
				p.position.y = 0;
				p.position.z = 0;
		}
		
		//平面のメッシュはobjに直接置かないと触った判定がとれないので注意
		obj.add(pMesh);
		
		var lineSize0 = 0.1;
		var lineSize1 = 0.2;
		
		var cg0 = new THREE.CylinderGeometry(lineSize0, lineSize0, span * s, 5, 5, false);
		var cg1 = new THREE.CylinderGeometry(lineSize1, lineSize1, span * s, 5, 5, false);
		
		//辺
		var line0_0 = new THREE.Mesh(cg0, lm0);
		var line0_1 = new THREE.Mesh(cg0, lm0);
		var line0_2 = new THREE.Mesh(cg0, lm0);
		var line0_3 = new THREE.Mesh(cg0, lm0);
		
		var line1_0 = new THREE.Mesh(cg1, lm1);
		var line1_1 = new THREE.Mesh(cg1, lm1);
		var line1_2 = new THREE.Mesh(cg1, lm1);
		var line1_3 = new THREE.Mesh(cg1, lm1);
		
		line0_0.position.x = -span * s/2;
		line1_0.position.x = -span * s/2;
		
		line0_1.position.x = span * s/2;
		line1_1.position.x = span * s/2;
		
		line0_2.position.y = -span * s/2;
		line0_2.rotation.z = Math.PI/2;
		line1_2.position.y = -span * s/2;
		line1_2.rotation.z = Math.PI/2;
		
		line0_3.position.y = span * s/2;
		line0_3.rotation.z = Math.PI/2;
		line1_3.position.y = span * s/2;
		line1_3.rotation.z = Math.PI/2;
		
		
		
		line0_0.name = "line0_0";
		line0_1.name = "line0_1";
		line0_2.name = "line0_2";
		line0_3.name = "line0_3";
		
		line1_0.name = "line1_0";
		line1_1.name = "line1_1";
		line1_2.name = "line1_2";
		line1_3.name = "line1_3";
		
		p.add(line0_0);
		p.add(line0_1);
		p.add(line0_2);
		p.add(line0_3);
		
		p.add(line1_0);
		p.add(line1_1);
		p.add(line1_2);
		p.add(line1_3);
		
		return p;
	}
	catch(e)
	{
		alert("createSelectPlane:" + e.toString());
	}
}

function render()
{
	try
	{
	
		requestAnimationFrame(render);
		
		controls.update();
		
		for(var i=0; i<textArray.length; i++)
		{
			textArray[i].rotation.setFromRotationMatrix( camera.matrix );
		}
		
		renderer.render(scene, camera);
	}
	catch(e)
	{
		alert("render:" + e.toString());
	}
}

function changePlaneDisplay(e)
{
	changeGraphDisplay();
}

function changeGraphDisplay()
{
	try
	{
		var f = $("#check0").prop("checked");
		obj.getChildByName("p0").visible = f;
		planeXY.visible = f;
		
		f = $("#check1").prop("checked");
		obj.getChildByName("p1").visible = f;
		planeYZ.visible = f;
		
		f = $("#check2").prop("checked");
		obj.getChildByName("p2").visible = f;
		planeZX.visible = f;
	}
	catch(e)
	{
		alert("changeGraphDisplay:" + e.toString());
	}
}

function selectObjectHandler(e)
{
	try
	{
		var mouse = new THREE.Vector2();
		
		var elm = document.getElementById("graphBlock");
		
		var pX = e.pageX - $(elm).offset().left;
		var pY = e.pageY - $(elm).offset().top;
		
		if(e.type == "touchstart")
		{
			if(e.targetTouches == undefined)
			{
				pX = e.originalEvent.targetTouches[0].pageX - $(elm).offset().left;
				pY = e.originalEvent.targetTouches[0].pageY - $(elm).offset().top;
			}
			else
			{
				pX = e.targetTouches[0].pageX - $(elm).offset().left;
				pY = e.targetTouches[0].pageY - $(elm).offset().top;
			}
		}
		else
		{
			pX = e.pageX - $(elm).offset().left;
			pY = e.pageY - $(elm).offset().top;
		}
		
		mouse.x = (pX / cW) * 2 - 1;
		mouse.y = -(pY / cH) * 2 + 1;
		
		var ray = new THREE.Raycaster();
		
		ray.setFromCamera(mouse, camera);
		
		var intersects = ray.intersectObjects(obj.children);
		
		if(intersects.length > 0)
		{
			for(var i=0; i<intersects.length; i++)
			{
				if(intersects[i].object.name.substring(0, 1) == "p")
				{
					rotFlag = false;
					
					if(e.type == "touchstart")
					{
						document.addEventListener("touchend", releaseHandler);
					}
					else
					{
						document.addEventListener("mouseup", releaseHandler);
					}
					
					var n = parseInt(intersects[i].object.name.substring(1, 2));
					
					changeSelectObject(n);
					
					break;
				}
			}
		}
	}
	catch(e)
	{
		alert("selectObjectHandler:" + e.toString());
	}
}

function changeSelectObject(n)
{
	var f = $("#check"+n).prop("checked");
	changeSelectPlane(n, !f);
	$("#check"+n).prop("checked", !f);
}

function releaseHandler(e)
{
	try
	{
		rotFlag = true;
		
		if(e.type == "touchend")
		{
			document.removeEventListener("touchend", releaseHandler);
		}
		else
		{
			document.removeEventListener("mouseup", releaseHandler);
		}
	}
	catch(e)
	{
		alert("releaseHandler:" + e.toString());
	}
}

function changeSelectPlane(n, f)
{
	try
	{
		if(n == -1 || n == 0)
		{
			planeXY.getChildByName("line0_0").visible = !f;
			planeXY.getChildByName("line0_1").visible = !f;
			planeXY.getChildByName("line0_2").visible = !f;
			planeXY.getChildByName("line0_3").visible = !f;
			
			planeXY.getChildByName("line1_0").visible = f;
			planeXY.getChildByName("line1_1").visible = f;
			planeXY.getChildByName("line1_2").visible = f;
			planeXY.getChildByName("line1_3").visible = f;
		}
		
		if(n == -1 || n == 1)
		{
			planeYZ.getChildByName("line0_0").visible = !f;
			planeYZ.getChildByName("line0_1").visible = !f;
			planeYZ.getChildByName("line0_2").visible = !f;
			planeYZ.getChildByName("line0_3").visible = !f;
			
			planeYZ.getChildByName("line1_0").visible = f;
			planeYZ.getChildByName("line1_1").visible = f;
			planeYZ.getChildByName("line1_2").visible = f;
			planeYZ.getChildByName("line1_3").visible = f;
		}
		
		if(n == -1 || n == 2)
		{
			planeZX.getChildByName("line0_0").visible = !f;
			planeZX.getChildByName("line0_1").visible = !f;
			planeZX.getChildByName("line0_2").visible = !f;
			planeZX.getChildByName("line0_3").visible = !f;
			
			planeZX.getChildByName("line1_0").visible = f;
			planeZX.getChildByName("line1_1").visible = f;
			planeZX.getChildByName("line1_2").visible = f;
			planeZX.getChildByName("line1_3").visible = f;
		}
	}
	catch(e)
	{
		alert("changeSelectPlane:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = camera.position.x;
		array[0][1] = camera.position.y;
		array[0][2] = camera.position.z;
		array[0][3] = controls.object.zoom;
		
		array[1] = [$("#check0").prop("checked"), $("#check1").prop("checked"), $("#check2").prop("checked")];
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		camera.position.x = array[0][0];
		camera.position.y = array[0][1];
		camera.position.z = array[0][2];
		controls.object.zoom = array[0][3];
		controls.object.updateProjectionMatrix();
		
		$("#check0").prop("checked", array[1][0]);
		
		$("#check1").prop("checked", array[1][1]);
		
		$("#check2").prop("checked", array[1][2]);
	
		changeGraphDisplay();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		$("#check0").prop("checked", false);
		$("#check1").prop("checked", false);
		$("#check2").prop("checked", false);
		
		camera.position.x = 50;
		camera.position.y = 50;
		camera.position.z = 100;
		controls.object.zoom = 1;
		controls.object.updateProjectionMatrix();
		
		changeGraphDisplay();
		
		//changeSelectPlane(-1, false);
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
